/*
 * 作者：wy
 * 版本：1.0.0
 * 用途： 融云代理
 * 来源：为保证模块调用唯一性 统一管理
 * 创建时间：2020年2月12日 14:08:21
 * 最后修改时间：
 * 文档地址：https://docs.apicloud.com/Client-API/Open-SDK/rongCloud2
 */
(function (window) {
	/*start*/
	var wy = {}, module_name = "rongCloud2", module;
	/**
	 * 模块初始化方法 在应用开启时调用即可 
	 */
	wy.init = function () {
		module = api.require(module_name);
		if (!module) { return false; }
		api.addEventListener({ name: module_name }, wy.listener);
		return true;
	};
	/**
	 * 模块监听事件并调用方法返回 
	 * type：参考融云方法名
	 * param：融云方法参数
	 * monitor：传入时会代替默认接收监听		默认监听为：zyRongCloud_+方法名		成功方法	ret.value.success	错误 ret.value.error
	 */
	wy.listener = function (_ret) {
		var type = _ret.value.type || "";//对应的方法名
		var param = _ret.value.param || {};//请求参数方法
		if(type == "getUnreadCountByConversationTypes"){//获取未读 增加不统计免打扰数量
			param.containBlocked = false;
		}
		var monitor = _ret.value.monitor || (module_name + "_" + type);//监听器 会替换默认监听事件
		console.error('融云发事件：' + type);//不写监听不到消息 见鬼
		try {
			eval("module." + type + "(param,function(){wy.returnMsg(arguments[0],arguments[1],param,monitor,type);});");
		} catch (e) {
			console.error('rongCloud语句异常：' + e.message);
		}
	};
	/**
	 * 方法返回事件 传入了type 可以做特殊处理 arguments[4]
	 */
	wy.returnMsg = function () {
		api.sendEvent({ extra: { success: arguments[0], error: arguments[1], param: arguments[2] }, name: arguments[3] });
	};
	/**
	 * 添加页面监听 
	 */
	wy.addListener = function (_type, _log, _param, _monitor) {
		var monitor = _monitor || (module_name + '_' + _type);
		if (_monitor)
			api.addEventListener({ name: monitor }, function (ret) {
				//			console.log(api.systemType+"-"+ (monitor)+"："+JSON.stringify(ret.value.success) + ",err:" + JSON.stringify(ret.value.error));
				//收到来电
				if (_monitor == "addCallReceiveListener_didReceiveCall") {
					ret = ret.value.success;
					var myParam = {};
					myParam.pageType = "page";//打开页面方式	home 首页一级模块	 page 作为页面被打开
					myParam.pageOnly = T.getNum();//表示页面唯一参数	必传
					myParam.page_type = 1;
					myParam.callId = ret.callSession.callId;
					myParam.mediaType = ret.callSession.mediaType;
					myParam.targetId = ret.callSession.targetId;
					myParam.otherMsg = ret.callSession;
					T.openWin("rongCloudVideo_win" + myParam.pageOnly, "widget://html/module/mo_rongCloudVideo/rongCloudVideo_win.html", myParam, true, false);
				}
			});
		api.sendEvent({ name: module_name, extra: { type: _type, param: _param, monitor: monitor } });
	};
	/**
	 * 初始化之后 监听一系列监听 
	 */
	wy.initAfter = function () {
		//	wy.addListener('isCallEnabled','是否支持',{});
		//		wy.addListener('addCallReceiveListener','收到来电的事件',{target:'didReceiveCall'},'addCallReceiveListener_didReceiveCall');
		//		wy.addListener('addCallReceiveListener','权限请求事件',{target:'permissionRequest'},'addCallReceiveListener_permissionRequest');
		////		wy.addListener('addCallReceiveListener','接收到通话呼入的远程通知的事件',{target:'didReceiveCallRemoteNotification'},'addCallReceiveListener_didReceiveCallRemoteNotification');//苹果有用
		////		wy.addListener('addCallReceiveListener','接收到取消通话的远程通知的事件',{target:'didCancelCallRemoteNotification'},'addCallReceiveListener_didCancelCallRemoteNotification');//苹果有用
		////		wy.addListener('addCallSessionListener','电话已拨出事件',{target:'callOutgoing'},'addCallSessionListener_callOutgoing');//只有安卓有用
		//		wy.addListener('addCallSessionListener','收通话已接通的事件',{target:'didConnect'},'addCallSessionListener_didConnect');
		//		wy.addListener('addCallSessionListener','通话已结束的事件',{target:'didDisconnect'},'addCallSessionListener_didDisconnect');
		////		wy.addListener('addCallSessionListener','对端用户正在振铃的事件',{target:'remoteUserDidRing'},'addCallSessionListener_remoteUserDidRing');//都有的监听 但是没啥用
		//		wy.addListener('addCallSessionListener','有用户被邀请加入通话的事件',{target:'remoteUserDidInvite'},'addCallSessionListener_remoteUserDidInvite');
		//		wy.addListener('addCallSessionListener','对端用户加入了通话的事件',{target:'remoteUserDidJoin'},'addCallSessionListener_remoteUserDidJoin');
		//		wy.addListener('addCallSessionListener','对端用户切换了媒体类型的事件',{target:'remoteUserDidChangeMediaType'},'addCallSessionListener_remoteUserDidChangeMediaType');
		//		wy.addListener('addCallSessionListener','对端用户开启或关闭了摄像头的状态的事件',{target:'remoteUserDidDisableCamera'},'addCallSessionListener_remoteUserDidDisableCamera');
		//		wy.addListener('addCallSessionListener','对端用户挂断',{target:'remoteUserDidLeft'},'addCallSessionListener_remoteUserDidLeft');//ios有用
		////		wy.addListener('addCallSessionListener','彩铃事件',{target:'shouldAlertForWaitingRemoteResponse'},'addCallSessionListener_shouldAlertForWaitingRemoteResponse');//苹果有用
		////		wy.addListener('addCallSessionListener','来电铃声的事件',{target:'shouldRingForIncomingCall'},'addCallSessionListener_shouldRingForIncomingCall');//苹果有用
		////		wy.addListener('addCallSessionListener','停止播放铃声',{target:'shouldStopAlertAndRing'},'addCallSessionListener_shouldStopAlertAndRing');//苹果有用
		//		wy.addListener('addCallSessionListener','通话过程中的错误事件',{target:'errorDidOccur'},'addCallSessionListener_errorDidOccur');
		//		wy.addListener('addCallSessionListener','当前通话网络状态，每两秒触发一次',{target:'networkTxQuality'},'addCallSessionListener_networkTxQuality');//ios有用
		//		wy.addListener('addCallSessionListener','发送的丢帧率',{target:'networkSendLost'},'addCallSessionListener_networkSendLost');//安卓有用
		//		wy.addListener('addCallSessionListener','接收的丢帧率',{target:'networkReceiveLost'},'addCallSessionListener_networkReceiveLost');//安卓有用
		wy.addListener('setOnReceiveMessageListener', '收到消息监听', {});
		wy.addListener('setConnectionStatusListener', '状态改变监听', {});
		wy.addListener('setOnMessageRecalledListener', '撤回消息监听', {});
	}
	/*end*/
	eval("window.$" + module_name + " = wy;");
})(window);