/**
 * 介绍：通用页面引用js 每个页面必须增加 
 * var vmData,vmWatch,vmMethods;
 */

//Vue对象
var vm,general_fs,general_docReader,general_docInteraction;
/**
 * 默认data参数 每个页面都有的参数
 */
var DEFAULT_DATA = {
	safeAreaTop:0,//手机端状态栏高度
	safeAreaBottom:0,//iphoneX 等有底部虚拟条的
	pageParam:{},//接收前一个页面的参数
	pageType:"",//页面类型 page或home 默认为page
	
	appFont: "",//app全局字体
	appFontSize:"",//app全局字体大小
	appTheme:"",//app全局主题色
	
	seachText:"",//搜索词
	seachPlaceholder:"搜索",//搜索提示
	
	showSkeleton:true,//是否展示骨架屏
	pageNot:{url:"./image/icon_no_data.png",text:"暂无数据"},//页面空时的提示词
	firstAjax:false,//首次网络请求是否成功
	
	tomcatAddress:"http://www.cszysoft.com:9090/",
};
/**
 * 默认watch参数 每个页面都有 
 */
var DEFAULT_WATCH = {
	
};
/**
 * 默认methods参数 每个页面都有 
 */
var DEFAULT_METHODS = {
	//默认的初始化方法
	defalutInit:function(){
		var that = this;
		that.changeConfiguration();
		$api.removeCls($api.byId("app"), "none");
		$api.css($api.byId("app"),"font-family:"+that.appFont+";");
		if(T.isAPICloud()){
			that.cleanIosDelay();
			that.safeAreaTop = api.safeArea.top;//顶部高度
			that.safeAreaBottom = api.safeArea.bottom;//底下导航条高度
			that.pageParam = api.pageParam || {};//页面参数
			that.pageType = that.pageParam.pageType || "page";//页面类型 首页打开 还是页面打开
			//接收修改过后的配置 
			T.addEventListener('changeConfiguration',function(ret,err){
				switch(ret.value.type){
					default:that.changeConfiguration();break;
				}
			});
		}
	},
	init:function(){},
	//消除IOS默认300延时
	cleanIosDelay:function(){
		var that = this;
		setTimeout(function(){
			if(T.systemType() == "ios"){
//				try{FastClick.attach(document.body);}catch(e){console.error(e.message)}
			}
		},10);
	},
	//全局配置
	changeConfiguration:function(){
		var that = this;
		that.appFont = T.getPrefs("appFont") || "heiti";
		var randomNum = Math.floor(Math.random()*9),randomText = "";
		for(var i = 0; i < randomNum; i++){
			randomText += "0";
		}
		that.appFontSize = Number((T.getPrefs("appFontSize") || "16") + "."+randomText+"1");
		that.appTheme = T.getPrefs("appTheme") || "#4e6ef2";
	},
	
	//样式加载配置	字体不能改	大小传过来 +几		主题色不能改
	loadConfiguration:function(_changeSize,_max){
		var that = this;
		var changeSize = _changeSize || 0;
		return "font-size:"+((that.appFontSize>_max?_max:that.appFontSize+changeSize)*0.01)+"rem;font-family:"+that.appFont+";";
	},
	//根据配置大小	设置按钮 图片等宽高 +-N
	loadConfigurationSize:function(_changeSize,_who){
		var that = this;
		var changeSize = _changeSize || 0;
		var returnCss = "";
		var cssWidth,cssHeight;
		if(T.isArray(_changeSize)){
			cssWidth = "width:"+((that.appFontSize+(_changeSize[0] || 0))*0.01)+"rem;";
			cssHeight = "height:"+((that.appFontSize+(_changeSize[1] || 0))*0.01)+"rem;";
		}else{
			cssWidth = "width:"+((that.appFontSize+changeSize)*0.01)+"rem;";
			cssHeight = "height:"+((that.appFontSize+changeSize)*0.01)+"rem;";
		}
		if(!_who){
			returnCss = cssWidth + cssHeight;
		}else{
			returnCss = _who == 'w'?cssWidth:cssHeight;
		}
		return returnCss;
	},
	// ================================================================================
	//获取item	只有一层级的时候 会返回 当前index	_i
	getItemForKey:function(_value,_list,_key){
		var that = this;
		for(var i = 0; i < _list.length; i++){
			if(T.isArray(_list[i])){
				for(var j = 0; j < _list[i].length; j++){
					if(_list[i][j][_key||"key"] == _value){
						return _list[i][j];
					}
				}
			}else{
				if(_list[i][_key||"key"] == _value){
					_list[i]['_i'] = i;
					return _list[i];
				}
			}
		}
		return false;
	},
	//在集合中删除第一个参数obj和index都可以或对比字符串	第二个传入集合	第三个为对比key
	delItemForKey:function(_obj,_list,_key){
		var that = this;
		if(!(_obj+""))return;
		if(T.isPositiveInteger(_obj)){
			_list.splice(_obj,1);//删除起始角标	 /	几个数量
		}else{
			var contrastObj = T.isString(_obj)?_obj:_obj[_key||"url"];
			for (var i = 0; i < _list.length; i++) {
				if(_list[i][_key||"url"] == contrastObj)
					_list.splice(i,1);
			}
		}
	},
	//图片共用方法集合 ================================================================================
	//共用缓存方法	item需要一个url参数
	cacheImg:function(_item,_thumbnail,_url){
		var that = this;
		if(_item._imgAjax)
			return;
		_item._imgAjax = true;//是否请求过	有就不再请求
		T.imageCache({
			url: _url || _item.url,
			thumbnail: _thumbnail?true:false
		}, function(ret, err) {
			if (ret.status) {
				_item.url = ret.url;
				_item.showUrl = ret.url;
			}
		});
	},
	//打开预览图片 需要item带url的list 和当前第几页 没传就第1页
	previewImg: function(_list, _index, _key) {
		var that = this;
		var images = [];
		var nowIndex = _index;
		if(T.isArray(_list)){
			for (var i = 0; i < _list.length; i++) {
				images.push(_list[i][_key || "url"]);
			}
		}else{
			images.push(_list[_key || "url"]);
			nowIndex = 0;
		}
		if(T.isAPICloud()){
			T.openImageBrowser({imageUrls:images,activeIndex:nowIndex});
		}else{
			vant.ImagePreview({images: images,startPosition:nowIndex});
		}
	},
	//通用列表页面点击 搜索确定事件
	//	@input 输入中监听			@keyup.enter 回车
	btnSearch:function(_type){
		if(!_type)
			this.$refs["btnSearch"].blur();
		T.goPageTop();
		if(T.isAPICloud()){
			T.refreshHeaderLoading();
		}
	}
};
var nvmData = {},nvmWatch = {},nvmMethods = {};
T.ready(function(){
	try{
		nvmData = T.setNewJSON(DEFAULT_DATA,vmData);
		nvmWatch = T.setNewJSON(DEFAULT_WATCH,vmWatch);
		nvmMethods = T.setNewJSON(DEFAULT_METHODS,vmMethods);
	}catch(e){console.error(e.message)}
	vm = new Vue({
		el: '#app',
		data: nvmData,
		watch:nvmWatch,
		mounted: function () {//页面元素加载完成时调用
			var that = this;
			try{that.defalutInit();}catch(e){console.error(e.message)}
			try{that.init();}catch(e){console.error(e.message)}
		},
		methods: nvmMethods
	});
});