﻿/*
 * ━━━━━━神兽出没━━━━━━
Ho~　★★★★★★
　　○★★★★★★★○	
　　★★　　　 　★★	
　★★　∩　　∩　 ★★	
　★★　　　●　 　★★	
　★★　　　　　　★★	
　　★★　　　　★★	
　　　　★★★★　　　◢◤	
　　╭　〡〡〡〡　╮╱	
　　　—┘—┘└—└—
 * ━━━━━━感觉萌萌哒━━━━━━
 */
/**
 * 2017/01/16 16：16
 * 用于Apicloud开发的通用js
 * by 半颗糖。
 */
(function(window){
	var T = {};
	T.NET_ERR = '网络不给力，请稍后再试';
	T.NET_OK = '操作成功';
	T.NET_NO = '操作失败，请重试';
	T.JK_ERR = '接口异常，请联系技术';
	T.LOAD_ING = '加载中，请稍候...';
	T.LOAD_MORE = '点击加载更多';
	T.LOAD_ALL = '已加载完';
	T.LOAD_NO = '暂无数据';
	T.LOAD_NOT = '页面尚未加载完成，请刷新重试';
	T.fs = null;
	//判断是否是WebView
	T.isWebView = function() {
		var that = this;
		var host = window.location.host;
		var path = window.location.href;
		if (host == "" && ((path.toLowerCase().indexOf('file:///storage') > -1)) || ((path.toLowerCase().indexOf('file:///android_asset') > -1)) || ((path.toLowerCase().indexOf('file:///data') > -1)) || (path.toLowerCase().indexOf('file:///var/') > -1) || (path.toLowerCase().indexOf('contents:///') > -1) || (path.toLowerCase().indexOf('file:///private/') > -1)) {
			return true;
		} else {
			return false;
		}
	};
	//判断是否是APICloud
	T.isAPICloud = function() {
		var that = this;
		if ( typeof api !== 'undefined' && typeof api.openWin !== 'undefined' && that.isWebView()) {
			return true;
		} else {
			return false;
		}
	};
	//对象是否为	某种类型
	T.isTargetType = function(obj, typeString) {
		return typeof obj === typeString;
	};
	//是否为方法 
	T.isFunction = function(obj) {
		var that = this;
		return that.isTargetType(obj, "function");
	};
	//是否为字符串
	T.isString = function(obj) {
		var that = this;
		return that.isTargetType(obj, "string") && obj != null && obj != undefined;
	};
	//是否为 正整数 数字
	T.isPositiveInteger = function(_int) {
		var that = this;
		var reg = /^[\d]+$/; //^-?[0-9]\d*$	 正则数字 
		return reg.test(_int) && _int != null && _int != undefined;
	};
	//是否为数组
	T.isArray = function(arr) {
		return (toString.apply(arr) === '[object Array]') || arr instanceof NodeList;
	};
	//是否为对象
	T.isObject = function(obj) {
		var that = this;
		return (that.isTargetType(obj, "object") && obj != null && obj != undefined);
	};
	/**
	 * 页面开始函数任何页面必须调用
	 */
	T.ready = function(callback) {
		var that = this;
		if (that.isWebView()) {
			apiready = function() {
				if (that.isFunction(callback)) {
					callback();
				}
			};
		} else {
			window.onload = function() {
				if (that.isFunction(callback)) {
					callback();
				}
			}
		}
	};
	//TODO ######################### 小工具
	/**
	 * 随机 10亿中的一位数	一般用于字符串唯一性
	 */
	T.getNum = function() {
		var that = this;
		return Math.floor(Math.random()*1000000000);
	};
	/**
	 * 直达页面顶部
	 */
	T.goPageTop = function(){
		var that = this;
		if(that.isAPICloud()){
			//调用apicloud返回顶部方法
			api.pageUp({top:true});
		}else{
			//原生js方法 出处：https://www.cnblogs.com/Crysta1/p/6179907.html
			(function smoothscroll(){
				var currentScroll = document.documentElement.scrollTop || document.body.scrollTop;
				if (currentScroll > 0) {
					 window.requestAnimationFrame(smoothscroll);
					 window.scrollTo (0,currentScroll - (currentScroll/5));
				}
			})();
		}
	};
	/**
	 * 到DOM位置
	 */
	T.toDomTop = function(_dom){
		var that = this;
		(function smoothscroll(){
			var currentScroll = _dom.scrollTop;
			if (currentScroll > 0) {
				 window.requestAnimationFrame(smoothscroll);
				 _dom.scrollTop = currentScroll - (currentScroll/5)
			}
		})();
	};
	/**
	 * 直达页面底部
	 */
	T.goPageButtom = function(){
		var that = this;
		if(that.isAPICloud()){
			//调用apicloud直达底部方法
			api.pageDown({bottom:true});
		}else{
			//原生js方法 动画版没找到 后面再说
			document.getElementsByTagName('BODY')[0].scrollTop=document.getElementsByTagName('BODY')[0].scrollHeight;
		}
	};
	/**
	 * 取系统当前时间
	 */
	T.getTime = function(_data){
		var that = this;
		var nowTime = new Date();
		if(_data){
			if(that.isString(_data)){
				nowTime = new Date(_data);
			}else{
				nowTime = _data;
			}
		}
		var year = nowTime.getFullYear();
		var month = nowTime.getMonth() + 1;//月份从0开始的
		var day = nowTime.getDate();
		var hours = nowTime.getHours();
		var minutes = nowTime.getMinutes();
		var seconds = nowTime.getSeconds();
		month = (month < 10)?"0"+month:month;
		day = (day < 10)?"0"+day:day;
		hours = (hours < 10)?"0"+hours:hours;
		minutes = (minutes < 10)?"0"+minutes:minutes;
		seconds = (seconds < 10)?"0"+seconds:seconds;
		return year+"-"+month+"-"+day+" "+hours+":"+minutes+":"+seconds;
	}
	/**
	 * 格式化秒
	 * @param int	value 总秒数
	 * @return string result 格式化后的字符串
	 */
	T.formatSeconds = function(value,_specific) {
		if(value < 0)return "";
		var theTime = parseInt(value);// 需要转换的时间秒
		var theTime1 = 0;// 分
		var theTime2 = 0;// 小时
		var theTime3 = 0;// 天
		if(theTime > 60) {
			theTime1 = parseInt(theTime/60);
			theTime = parseInt(theTime%60);
			if(theTime1 > 60) {
		 		theTime2 = parseInt(theTime1/60);
		 		theTime1 = parseInt(theTime1%60);
			 	if(theTime2 > 24){
					//大于24小时
					theTime3 = parseInt(theTime2/24);
					theTime2 = parseInt(theTime2%24);
				}
			}
		}
		var result = '';
		if(theTime > 0){
			result = ""+parseInt(theTime)+"秒";
		}
		if(theTime1 > 0) {
			result = ""+parseInt(theTime1)+"分"+(_specific?result:"");
		}
		if(theTime2 > 0) {
			result = ""+parseInt(theTime2)+"小时"+(_specific?result:"");
		}
		if(theTime3 > 0) {
			result = ""+parseInt(theTime3)+"天"+(_specific?result:"");
		}
		return result; 
	}
	/**
	 * 一个旧json 和一个新json 合成一个新的json 默认替换 param【旧对象，新对象，传true或1 就不替换】
	 */
	T.setNewJSON = function(obj,newobj,_ifReplace){
		//重写 不然一个页面写2次 比如framegroup的时候	就会重复的问题
		var returnObj = {};
		for(var key in obj){
			returnObj[key] = obj[key];
		}
		for(var key in newobj){
			if(_ifReplace){
				if(returnObj.hasOwnProperty(key)) //加上就不替换	不加就替换
					continue;
			}
			returnObj[key] = newobj[key];
		}
		return returnObj;
	}
	/**
	 * 去掉html所有标签
	 */
	T.delHtmlTag = function(str) {
		if(str)
			return str.replace(/<[^>]+>/g, "");
	}
		
	//TODO ######################### apicloud方法 必须判断在网页中或app中的2种情况做处理
	
	/**
	 * 设备唯一标识，字符串类型 
	 */
	T.deviceId = function(){
		var that = this;
		if (that.isAPICloud()) {
			return api.deviceId;
		}else{
			return "0";
		}
	};
	/**
	 * 打开win-----name页面名字,url页面地址,pageParam传值参数,reload重新载入时是否刷新,allowEdit是否可长按复制
	 */
	T.openWin = function(name,url,pageParam,reload,allowEdit) {
		var that = this;
		var delay=0;
		var o = {
			name:name,
			url:url,
			pageParam:pageParam?pageParam:{},
			bgColor:"#FFF",
			bounces:false,
			slidBackEnabled:false,//ios滑动返回
			hScrollBarEnabled:false,//是否显示水平滚动条
			animation : {
				type : "push",
				subType:"from_right",
				duration:300
			},
			reload:reload,	// 是否可以刷新
			allowEdit:allowEdit,	// 是否可以编辑
			delay:delay,
			overScrollMode:"scrolls"
		};
//	if(!that.fs){
//		that.fs = api.require('fs');
//	}
//	if(o.url.indexOf('http') != 0){
//			var ifExist = that.fs.existSync({path: o.url});
//			if(!ifExist.exist || ifExist.directory){//如果不存在 并且为文件夹 就不跳转 这链接有问题
//				that.toast("这个链接有问题："+o.url);
//				return;
//			}
//	}
		if (that.isAPICloud()) {
			if(that.systemType() == 'ios'){
				o.delay = 0;
			}else{
				o.delay = 50;
			}
			api.openWin(o);
		} else {
			if (parent && parent.window) {
				parent.window.location = url;
			} else {
				window.location = url;
			}
		}
	};
	/**
	 * 关闭win-----name要关闭的名字 不写则关闭当前	animation关闭页面动画效果 传none则不要动画
	 */
	T.closeWin = function(name,animation) {
		var that = this;
		var o = {};
		if (that.isAPICloud()) {
			if (name) {
				o.name = name;
			}
//			o.animation = animation=="none"?{type:"none"}:{type:"push",subType:"from_"+(animation?animation:"right"),duration:300};
			api.closeWin(o);
		} else {
			try {
				parent.window.history.go(-1);
			} catch (e) {
				window.history.go(-1);
			}
		}
	};
	/**
	 *	打开frame(有特殊大小的frame请自行调用api.openFrame处理)-----name页面名字,url页面地址,pageParam传值参数,reload重新载入时是否刷新,allowEdit是否可长按复制,marginTop头部距离顶部多少,marginBottom底下距离多少,animation动画划动边 top right bottom left,progress传page时为进度条
	 */
	T.openFrame = function(name,url,pageParam,reload,allowEdit,marginTop,marginBottom,animation,progress) {
		var that = this;
		var anima = animation?{type:"push",subType:"from_"+animation,duration:300}:{type:"none"};
		var o = {
			name: name,
			url: url,
			rect: {
				x: 0,
				y: 0,
				w: 'auto',
				h: 'auto',
				marginLeft : 0,
				marginTop : marginTop?marginTop - 1:0,
				marginBottom : marginBottom?marginBottom:0,
				marginRight : 0
			},
			pageParam:pageParam?pageParam:{},
			bounces: false,
			hScrollBarEnabled: false,
			scaleEnabled:true,
			progress:progress?{
				type:progress?progress:"default",
				title:"加载中",
				text:"请稍候...",
				color:"#45C01A"
			}:null,
			reload:reload,
			allowEdit:true,//去除设置 默认都可以复制粘贴
			animation:anima,
			overScrollMode:"scrolls",
			defaultRefreshHeader:"swipe"
		};
		//适应新写法
		if(that.isObject(name)){
			o = that.setNewJSON(o,name);
		}
//		if(!that.fs){
//		that.fs = api.require('fs');
//	}
//	if(o.url.indexOf('http') != 0){
//			var ifExist = that.fs.existSync({path: o.url});
//			if(!ifExist.exist || ifExist.directory){//如果不存在 并且为文件夹 就不跳转 这链接有问题
//				that.toast("这个链接有问题："+o.url);
//				return;
//			}
//	}
		if (that.isAPICloud()) {
			api.openFrame(o);
		}else{
			if ($api.byId("T-frame") != null) {
				$api.attr($api.byId("T-frame"), "src", url);
				return;
			}
			var iframeHtml = '<iframe id="T-frame" src="'+ url +'" class="T-iframe" frameborder="0" scrolling="yes"></iframe>';
			if ($api.dom(".T-main") != null) {
				$api.css($api.dom(".T-main"), "position: relative;-webkit-overflow-scrolling: touch; overflow: scroll;");
				$api.html($api.dom(".T-main"), iframeHtml);
			} else {
				var html = '<div class="T-main T-flex-item" style="position: relative;-webkit-overflow-scrolling: touch; overflow: scroll;">';
				html += iframeHtml;
				html += '</div>';
				if (!$api.hasCls(document.body, "T-flexbox-vertical"))
					$api.addCls(document.body, "T-flexbox-vertical");
				$api.append(document.body, html);
			}
		}
	};
	/**
	 *	关闭frame-----name页面名字
	 */
	T.closeFrame = function(name) {
		var that = this;
		var o = {};
		if (name) {
			o.name = name;
		}
		if (that.isAPICloud()) {
			api.closeFrame(o);
		}
	};
	/**
	 *	frame页面高度 出处：https://www.cnblogs.com/zh-1721342390/p/9604801.html
	 */
	T.frameHeight = function(){
		var that = this;
		if(T.isAPICloud()){
			return api.frameHeight;
		}else{
			return document.body.offsetHeight;
		}
	};
	/**
	 *	获取设备类型
	 */
	T.systemType = function(){
		var that = this;
		if(T.isAPICloud()){
			return api.systemType;
		}else{
			return "";
		}
	};
	/**
	 *	发送事件监听
	 */
	T.sendEvent = function(_param){
		var that = this;
		if(T.isAPICloud()){
			api.sendEvent(_param);
		}
	};
	/**
	 *	设置事件监听-----name名字, callback回调方法
	 */
	T.addEventListener = function(name,callback) {
		var that = this;
		if (that.isAPICloud()) {
			api.addEventListener({name:name,extra:{threshold:50}}, function(ret, err) {
				if (that.isFunction(callback)) {
					callback(ret, err);
				}
			});
		}
	};
	/**
	 *	设置小型存储-----key键, value值
	 */
	T.setPrefs = function(key, value) {
		var that = this;
		if (that.isAPICloud()) {
			api.setPrefs({key:key,value:value});
		}else{
			$api.setStorage(key,value);
		}
	};
	/**
	 *	获取小型存储-----key键
	 */
	T.getPrefs = function(key) {
		var that = this;
		return that.isAPICloud()?api.getPrefs({sync:true,key:key}):$api.getStorage(key);
	};
	/**
	 *	删除小型存储-----key键
	 */
	T.removePrefs = function(key) {
		var that = this;
		if (that.isAPICloud()) {
			api.removePrefs({key:key});
		}else{
			$api.rmStorage(key);
		}
	};
	
	/**
	 *	设置弹出提示-----msg内容, location位置	top middle	 global是否全局弹出
	 */
	T.toast = function(msg,location,global){
		var that = this;
		if (that.isAPICloud()) {
			api.toast({
				msg:msg,
				duration:2000,
				location:location ? location : 'middle',
				global:global
			});
		}else{
			try{vant.Toast({duration: 2000,message:msg});}catch(e){}
		}
	}
	/**
	 *	设置弹出提示-----
	 */
	T.toastVant = function(param){
		var that = this;
		if(vant)
			vant.Toast(param);
		else
			alert(param.message);
	}
	/**
	 * 页面监听向右滑动关闭界面	可以得到返回监听 自己写关闭操作
	 */
	T.closeListener = function(callback){
		var that = this;
		if (that.isAPICloud()) {
			that.addEventListener('swiperight',function(ret,err){
				if (that.isFunction(callback)) {
					callback(ret, err);
				}else{
					that.closeWin();
				}
			});
		}
	}
	/**
	 * 页面设置下拉刷新-----param自定义参数,callback刷新时要做的事。加载完成后调用api.refreshHeaderLoadDone()方法恢复组件到默认状态
	 */
	T.setRefreshHeaderInfo = function(_params,callback){
		var that = this;
		var o = {
			bgColor : '#F5F5F5',
			textColor : '#8E8E8E',
			textDown : '下拉可以刷新...',
			textUp : '松开可以刷新...',
			textLoading:'刷新中...',
			textTime:"",
			showTime : false,
//			visible:false
		};
		o = that.setNewJSON(o,_params);
		if (that.isAPICloud()) {
			api.setRefreshHeaderInfo(o, function(ret,err){
				if (that.isFunction(callback)) {
					try{
						nvmData.footerBtnsShow = true;//下拉刷新时 把底下框展示出来
					}catch(e){console.error(e.message)}
					callback(ret,err);
				}
			});
		}
	}
	/**
	 * 获取winName
	 */
	T.winName = function(){
		var that = this;
		if (that.isAPICloud()) {
			return api.winName;
		}
	}
	/**
	 * 获取frameName 
	 */
	T.frameName = function(){
		var that = this;
		if (that.isAPICloud()) {
			return api.frameName;
		}
	}
	/**
	 * 设置 frame属性
	 */
	T.setFrameAttr = function(_params){
		var that = this;
		var defaultParam = {
			
		};
		defaultParam = that.setNewJSON(defaultParam,_params);
		if (that.isAPICloud()) {
			api.setFrameAttr(defaultParam);
		}
	}
	/**
	 * 图片缓存
	 */
	T.imageCache = function(_params,callback){
		var that = this;
		var defaultParam = {
			url:"",//图片远程地址
			encode:false,//是否对url进行编码。	java的默认不编码
			policy:"default",//缓存策略
			thumbnail:true,//使用缩略图
			//tag:"",//标识信息，将在回调中返回
		};
		defaultParam = that.setNewJSON(defaultParam,_params);
		if (that.isAPICloud()) {
			api.imageCache(defaultParam, function(ret, err) {
//				var img = new Image();
//				img.onload = function() {//图片地址是正确的
//				}
//				img.onerror = function() {//图片地址错误
//				}
//				img.src = ret.url;
				if (that.isFunction(callback)) {
					callback(ret,err);
				}
			});
		}else{
			callback({status:true,url:defaultParam.url});
		}
	}
	
	/**
	 * 通知下拉刷新数据加载完毕，组件会恢复到默认状态
	 */
	T.refreshHeaderLoadDone = function(){
		var that = this;
		if (that.isAPICloud()) {
			api.refreshHeaderLoadDone();
		}
	}
	/**
	 * 设置下拉刷新组件为刷新中状态
	 */
	T.refreshHeaderLoading = function(){
		var that = this;
		if (that.isAPICloud()) {
			api.refreshHeaderLoading();
		}
	}
	/**
	 * 显示加载框----- title刷新标题,modal是否拟态	true将不可交互
	 */
	T.showProgress = function(title,modal){
		var that = this;
		if (that.isAPICloud()) {
			api.showProgress({
					title: title?title:'加载中',
					text: '请稍候...',
					modal: modal
				});
		}
	}
	/**
	 * 隐藏进度提示框
	 */
	T.hideProgress = function(){
		var that = this;
		if (that.isAPICloud()) {
			api.hideProgress();
		}
	}
	/**
	 * 取消网络请求----- name标识名字
	 */
	T.cancelAjax = function(name){
		var that = this;
		if (that.isAPICloud()) {
			api.cancelAjax({tag:name});
		}
	}
	
	var db="";
	/**
	 * 网络请求----- url请求地址,tag请求标识,callback回调,logtext说明文字,method请求类型,data为post时传入的data
	 * 【2019年4月18日 11:23:59 增加参数 url传入json】 {u:"url"}
	 * u链接	 c是否缓存 ct缓存的时间(默认7秒) t(针对上拉加载更多不缓存请传入1或bottom) returnAll是否返回所有信息	frequency失败重复请求数
	 */
	T.ajax = function(url,tag,callback,logtext,method,data,header){
		var that = this;
		that.cancelAjax(tag);
		var getUrl = url;//请求链接
		var cacheIs = false; //是否直接取缓存 有些接口不能取 需要实时更新显示的
		var cacheTime = 7; //缓存时间 秒
		var cacheType = "";//当前加载类型 只缓存一次性的接口 加载更多则不缓存 那样有问题
		var returnAll = false;//是否返回header等所有信息
		var frequency = 0;//网络异常 重复请求次数
		var dataType = "json";//返回数据类型
		var paramData = {};
		var appSecret = "3d5ef53424f24852a8fc1d15a1072b42"
		var clientId = '816cc044c46247d987bbf611ced1cf5e'
		var timestamp = Date.parse(new Date()) / 1000 //时间戳，精确到秒
		if(!db){//只取一次	不要重复加载db
			db = api.require('db');
		}
		if(that.isObject(url)){
			returnAll = url.returnAll;//是否需要返回所有 response 信息（包括响应头、消息体、状态码），为 true 时，返回的头信息获取方法(ret.headers)，消息体信息获取方法(ret.body)，状态码获取方法(ret.statusCode)
			getUrl = url.u;//请求链接
			cacheIs = url.c;//是否缓存
			cacheTime = url.ct || 7;//缓存时间
			cacheType = url.t || "";//
			dataType = url.dt || "json";//
			frequency = url.frequency || 0;
			paramData = url.paramData || {};
			if(cacheType == "1" || cacheType == "bottom"){//如果接口是上拉加载 就不缓存
				cacheIs = false;
			}
			//通过网络请求 缓存
			var lowerUrl = getUrl.toLowerCase();//防止链接识别不到 全部先转成小写
			var cacheName = lowerUrl.split("&timestamp=")[0];//后面这个不一样 先截取掉
			if (that.isObject(data) && method == "post") {//增加post的缓存 
				cacheName += encodeURIComponent($api.trimAll(JSON.stringify(data)));
			}
			var userid = 0;//取到本人id	通过链接名字取缓存数据	（2019年4月18日 16:57:42不需要 好像链接中带了id）
			var sql = "select * from cacheInfo where id='"+userid+"' and type='"+cacheName+"' and area='0'";
			var sqlret = db.selectSqlSync({name: 'MYDATABASE',sql: sql});
			var sqlData = sqlret.data || [];
			if(sqlData.length != 0 && cacheIs ){//有数据的时候 并且取缓存的时候	&& method != "post"
				var nowTime = Math.round(new Date().getTime()/1000);
				var ifReturn = nowTime - Number(sqlData[0].time) < cacheTime;
				callback($api.strToJson(decodeURIComponent(sqlData[0].data)),"",ifReturn);
				if(ifReturn){ //当前时间 减去缓存的时候的时间	 不获取网络
					if(logtext)
						console.error(logtext+"走缓存："+getUrl);
					return;
				}
			}
		}
//	console.log(T.getPrefs("Sys_token"))
		var _header = header?header:{};
		var o = {
			url:getUrl,
			tag:tag,
			method:method ? method : "get",
			cache:true,
			timeout:50,
			dataType:dataType,
			headers:that.setNewJSON({
				"u-login-areaId":T.getAjaxSiteID(),
				"Authorization":T.getPrefs("Sys_token"),
				"timestamp":timestamp,
				"clientId":clientId,
				"signature":getSignature(getUrl,method,timestamp,clientId,appSecret),
				"u-app-user":true,
			},_header),
			returnAll:returnAll,
		};
		if (that.isObject(data) && o.method == "post") {
			o.data = data;
		}
		o = that.setNewJSON(o,paramData);
		if(logtext){
			if(o.method == "post"){
				console.log(logtext+"post【"+frequency+"】："+JSON.stringify(o));
			}else{
				console.log(logtext+"get【"+frequency+"】："+JSON.stringify(o));
			}
		}
		if(that.isAPICloud()) {
			api.ajax(o,function(ret,err){
				if(that.isFunction(callback)) {
					//失败时 看是否需要重复请求
					if(err){
						if(frequency > 0){
							var frequencyUrl = url;
							frequencyUrl.frequency--;
							that.ajax(frequencyUrl,tag,callback,logtext,method,data,header);
							return;
						}
					}
					if(logtext){
						if(ret)
							console.log("得到"+logtext+"返回结果ret："+JSON.stringify(ret));
						if(err)
							console.error("得到"+logtext+"返回结果err："+JSON.stringify(err));
					}
					if(ret){
						var errcode = ret.errcode || "";
						var errmsg = ret.errmsg || "";
						if(errcode == 302 && cacheType != "login"){//令牌失效
							that.hideProgress();
							that.sendEvent({name:'index',extra:{type:"verificationToken",errmsg:errmsg}});
							return;
						}
						db.executeSqlSync({
							name : 'MYDATABASE',
							sql : "delete from cacheInfo where id='"+userid+"' and type='"+cacheName+"' and area='0'"
						});
						db.executeSqlSync({
							name : 'MYDATABASE',
							sql : "insert into cacheInfo values('" + userid + "','"+cacheName+"','" + 0 + "', '" + Math.round(new Date().getTime()/1000) + "', '" + encodeURIComponent($api.jsonToStr(ret)) + "')"
						});
					}else{
						
					}
					callback(ret,err,true);
				}
			});
		}
	}
	
	var CryptoJS=CryptoJS||function(h,s){var f={},g=f.lib={},q=function(){},m=g.Base={extend:function(a){q.prototype=this;var c=new q;a&&c.mixIn(a);c.hasOwnProperty("init")||(c.init=function(){c.$super.init.apply(this,arguments)});c.init.prototype=c;c.$super=this;return c},create:function(){var a=this.extend();a.init.apply(a,arguments);return a},init:function(){},mixIn:function(a){for(var c in a)a.hasOwnProperty(c)&&(this[c]=a[c]);a.hasOwnProperty("toString")&&(this.toString=a.toString)},clone:function(){return this.init.prototype.extend(this)}},
		r=g.WordArray=m.extend({init:function(a,c){a=this.words=a||[];this.sigBytes=c!=s?c:4*a.length},toString:function(a){return(a||k).stringify(this)},concat:function(a){var c=this.words,d=a.words,b=this.sigBytes;a=a.sigBytes;this.clamp();if(b%4)for(var e=0;e<a;e++)c[b+e>>>2]|=(d[e>>>2]>>>24-8*(e%4)&255)<<24-8*((b+e)%4);else if(65535<d.length)for(e=0;e<a;e+=4)c[b+e>>>2]=d[e>>>2];else c.push.apply(c,d);this.sigBytes+=a;return this},clamp:function(){var a=this.words,c=this.sigBytes;a[c>>>2]&=4294967295<<
		32-8*(c%4);a.length=h.ceil(c/4)},clone:function(){var a=m.clone.call(this);a.words=this.words.slice(0);return a},random:function(a){for(var c=[],d=0;d<a;d+=4)c.push(4294967296*h.random()|0);return new r.init(c,a)}}),l=f.enc={},k=l.Hex={stringify:function(a){var c=a.words;a=a.sigBytes;for(var d=[],b=0;b<a;b++){var e=c[b>>>2]>>>24-8*(b%4)&255;d.push((e>>>4).toString(16));d.push((e&15).toString(16))}return d.join("")},parse:function(a){for(var c=a.length,d=[],b=0;b<c;b+=2)d[b>>>3]|=parseInt(a.substr(b,
		2),16)<<24-4*(b%8);return new r.init(d,c/2)}},n=l.Latin1={stringify:function(a){var c=a.words;a=a.sigBytes;for(var d=[],b=0;b<a;b++)d.push(String.fromCharCode(c[b>>>2]>>>24-8*(b%4)&255));return d.join("")},parse:function(a){for(var c=a.length,d=[],b=0;b<c;b++)d[b>>>2]|=(a.charCodeAt(b)&255)<<24-8*(b%4);return new r.init(d,c)}},j=l.Utf8={stringify:function(a){try{return decodeURIComponent(escape(n.stringify(a)))}catch(c){throw Error("Malformed UTF-8 data");}},parse:function(a){return n.parse(unescape(encodeURIComponent(a)))}},
		u=g.BufferedBlockAlgorithm=m.extend({reset:function(){this._data=new r.init;this._nDataBytes=0},_append:function(a){"string"==typeof a&&(a=j.parse(a));this._data.concat(a);this._nDataBytes+=a.sigBytes},_process:function(a){var c=this._data,d=c.words,b=c.sigBytes,e=this.blockSize,f=b/(4*e),f=a?h.ceil(f):h.max((f|0)-this._minBufferSize,0);a=f*e;b=h.min(4*a,b);if(a){for(var g=0;g<a;g+=e)this._doProcessBlock(d,g);g=d.splice(0,a);c.sigBytes-=b}return new r.init(g,b)},clone:function(){var a=m.clone.call(this);
		a._data=this._data.clone();return a},_minBufferSize:0});g.Hasher=u.extend({cfg:m.extend(),init:function(a){this.cfg=this.cfg.extend(a);this.reset()},reset:function(){u.reset.call(this);this._doReset()},update:function(a){this._append(a);this._process();return this},finalize:function(a){a&&this._append(a);return this._doFinalize()},blockSize:16,_createHelper:function(a){return function(c,d){return(new a.init(d)).finalize(c)}},_createHmacHelper:function(a){return function(c,d){return(new t.HMAC.init(a,
		d)).finalize(c)}}});var t=f.algo={};return f}(Math);
		(function(h){for(var s=CryptoJS,f=s.lib,g=f.WordArray,q=f.Hasher,f=s.algo,m=[],r=[],l=function(a){return 4294967296*(a-(a|0))|0},k=2,n=0;64>n;){var j;a:{j=k;for(var u=h.sqrt(j),t=2;t<=u;t++)if(!(j%t)){j=!1;break a}j=!0}j&&(8>n&&(m[n]=l(h.pow(k,0.5))),r[n]=l(h.pow(k,1/3)),n++);k++}var a=[],f=f.SHA256=q.extend({_doReset:function(){this._hash=new g.init(m.slice(0))},_doProcessBlock:function(c,d){for(var b=this._hash.words,e=b[0],f=b[1],g=b[2],j=b[3],h=b[4],m=b[5],n=b[6],q=b[7],p=0;64>p;p++){if(16>p)a[p]=
		c[d+p]|0;else{var k=a[p-15],l=a[p-2];a[p]=((k<<25|k>>>7)^(k<<14|k>>>18)^k>>>3)+a[p-7]+((l<<15|l>>>17)^(l<<13|l>>>19)^l>>>10)+a[p-16]}k=q+((h<<26|h>>>6)^(h<<21|h>>>11)^(h<<7|h>>>25))+(h&m^~h&n)+r[p]+a[p];l=((e<<30|e>>>2)^(e<<19|e>>>13)^(e<<10|e>>>22))+(e&f^e&g^f&g);q=n;n=m;m=h;h=j+k|0;j=g;g=f;f=e;e=k+l|0}b[0]=b[0]+e|0;b[1]=b[1]+f|0;b[2]=b[2]+g|0;b[3]=b[3]+j|0;b[4]=b[4]+h|0;b[5]=b[5]+m|0;b[6]=b[6]+n|0;b[7]=b[7]+q|0},_doFinalize:function(){var a=this._data,d=a.words,b=8*this._nDataBytes,e=8*a.sigBytes;
		d[e>>>5]|=128<<24-e%32;d[(e+64>>>9<<4)+14]=h.floor(b/4294967296);d[(e+64>>>9<<4)+15]=b;a.sigBytes=4*d.length;this._process();return this._hash},clone:function(){var a=q.clone.call(this);a._hash=this._hash.clone();return a}});s.SHA256=q._createHelper(f);s.HmacSHA256=q._createHmacHelper(f)})(Math);
		(function(){var h=CryptoJS,s=h.enc.Utf8;h.algo.HMAC=h.lib.Base.extend({init:function(f,g){f=this._hasher=new f.init;"string"==typeof g&&(g=s.parse(g));var h=f.blockSize,m=4*h;g.sigBytes>m&&(g=f.finalize(g));g.clamp();for(var r=this._oKey=g.clone(),l=this._iKey=g.clone(),k=r.words,n=l.words,j=0;j<h;j++)k[j]^=1549556828,n[j]^=909522486;r.sigBytes=l.sigBytes=m;this.reset()},reset:function(){var f=this._hasher;f.reset();f.update(this._iKey)},update:function(f){this._hasher.update(f);return this},finalize:function(f){var g=
		this._hasher;f=g.finalize(f);g.reset();return g.finalize(this._oKey.clone().concat(f))}})})();
	
	function getSignature (url,method,timestamp,clientId,appSecret){
		var HTTPMethod = method?method.toUpperCase():"GET",URI = '',param = '';
		try{
			if(url.indexOf('?')>=0){
				URI = url.split('?')[0].split(url.split('/')[3])[1];
				param = HTTPMethod=='POST'?'':(url.split('?')[1]);
			}else{
				URI = url.split(url.split('/')[3])[1];
			}
		}catch(e){
			console.error('语句异常：'+e.message);
		}
		var Message = timestamp + '-' + HTTPMethod + '-' + URI + '-' + getParam(HTTPMethod, param)
		var hash = ''+CryptoJS.HmacSHA256(Message, appSecret);
		return hash;
	}
	
	/**
	 * _httpMethod:请求方法（必须大写）
	 * _param参数字符串
	 * 将所有GET参数值的 char 值加和生成一个整数 POST方法返回0
	 */
	function getParam(_httpMethod, _param) {
		var jsonarr = _param.split("&");
		var signStr = ''
		for (var i in jsonarr) {
			var s = ''+jsonarr[i]
			var key = s.split("=")[0];
			var value = s.split("=")[1];
			if (key == 'timestamp' || key == 'clientId' || key == 'signatrue') {
				continue;
			}
			if(!value || value == '' || value == undefined || value == null){
				continue;
			}
			signStr += key;
		}
		if (signStr == '') {
			return 0;
		}
		var paramIntValue = 0;
		for (var i = 0; i < signStr.length; i++) {
			paramIntValue += signStr.charCodeAt(i);
		}
		if (_httpMethod == 'POST') {
			paramIntValue = 0
		}
		return paramIntValue;
	}
		
	/**
	 * 弹框	alert 【2019年9月11日 17:13:58】
	 * https://docs.apicloud.com/Client-API/api#33
	 */
	T.alert = function(_msg,callback){
		var that = this;
		var o = {
			title: '提示',
			msg: "",
			buttons:["确定"]
		};
		if(that.isObject(_msg)){
			o = that.setNewJSON(o,_msg);
		}else{
			o.msg = _msg;
		}
		if (that.isAPICloud()) {
			api.alert(o, function(ret, err) {
				if (that.isFunction(callback)) {
					callback(ret,err);
				}
			});
		}else{
			alert(o.msg);
		}
	}
	/**
	 * 弹出带两个或三个按钮的confirm对话框	confirm	【2019年9月11日 17:28:33】
	 * https://docs.apicloud.com/Client-API/api#1
	 */
	T.confirm = function(_param,callback){
		var that = this;
		var o = {
			title: '提示',
			msg: "",
			buttons:['确定', '取消']
		};
		o = that.setNewJSON(o,_param);
		if (that.isAPICloud()) {
			api.confirm(o, function(ret, err) {
				if (that.isFunction(callback)) {
					callback(ret,err);
				}
			});
		}
	}
	/**
	 * 弹出带两个或三个按钮和输入框的对话框	 prompt	【2019年9月11日 17:28:33】
	 * https://docs.apicloud.com/Client-API/api#1
	 */
	T.prompt = function(_param,callback){
		var that = this;
		var o = {
			title: '提示',
			msg: "",
			text:"",
			type:"text",
			buttons:['确定', '取消']
		};
		o = that.setNewJSON(o,_param);
		if (that.isAPICloud()) {
			api.prompt(o, function(ret, err) {
				if (that.isFunction(callback)) {
					callback(ret,err);
				}
			});
		}
	}
	/**
	 * 底部弹出框	actionSheet	【2019年9月11日 17:13:39】
	 * https://docs.apicloud.com/Client-API/api#1
	 */
	T.actionSheet = function(_param,callback){
		var that = this;
		var o = {
				title: '请选择',
				cancelTitle: '取消',
				destructiveTitle:"",
		};
		o = that.setNewJSON(o,_param);
		if (that.isAPICloud()) {
			api.actionSheet(o, function(ret, err) {
				if (that.isFunction(callback)) {
					callback(ret,err);
				}
			});
		}
	}
	/**
	 * APICloud才有的 提供动态检测应用是否已取得某个或多个权限
	 * https://docs.apicloud.com/Client-API/api#hasPermission
	 */
	T.hasPermission = function(one_per){
		var that = this;
		if (that.isAPICloud()) {
			var perms = new Array();
			if(!one_per){
				return;
			}
			if(one_per.indexOf(',') != -1){
				var one_pers = one_per.split(',');
				for(var i = 0; i < one_pers.length; i++){
					perms.push(one_pers[i]);
				}
			}else{
				perms.push(one_per);
			}
			var rets = api.hasPermission({list:perms});
			if(one_per.indexOf(',') != -1){//判断一堆时 就自己看	一般是一个一个判断
				that.alert('判断结果：' + JSON.stringify(rets));
	 			return;
			}else{
				return rets;
			}
		}
	}
	
	/**
	 * APICloud才有的 向系统请求某个或多个权限
	 * https://docs.apicloud.com/Client-API/api#requestPermission
	 */
	T.requestPermission = function(one_per,callback){
		var that = this;
		if (that.isAPICloud()) {
			var perms = new Array();
			if(!one_per){
				return;
			}
			if(one_per.indexOf(',') != -1){
				var one_pers = one_per.split(',');
				for(var i = 0; i < one_pers.length; i++){
					perms.push(one_pers[i]);
				}
			}else{
				perms.push(one_per);
			}
			api.requestPermission({
		 		list: perms,
		 		code: 100001
		 	}, function(ret, err){
		 		if(callback){
		 			callback(ret);
		 			return;
		 		}
//	 		var str = '请求结果：\n';
//	 		str += '请求码: ' + ret.code + '\n';
//	 		str += "是否勾选\"不再询问\"按钮: " + (ret.never ? '是' : '否') + '\n';
//	 		str += '请求结果: \n';
//	 		var list = ret.list;
//	 		for(var i in list){
//	 			str += list[i].name + '=' + list[i].granted + '\n';
//	 		}
//	 		that.alert(str);
		 		console.error(JSON.stringify(ret));
		 	});
		}
	}
	
	/**
	 * APICloud才有的 检测是否有权限 没有就请求
	 */
	T.confirmPer = function(perm){
		var that = this;
		if (that.isAPICloud()) {
			var has = that.hasPermission(perm);
			if(!has || !has[0] || !has[0].granted){
				var hintWord = {
					"camera":"相机",
					"storage":"存储",
					"photos":"照片",
					"microphone":"麦克风",
					"location":"位置",
				};
				var iosHint = "请在"+(api.uiMode=='phone'?'iPhone':'iPad')+"的“设置-隐私-"+hintWord[perm]+"”中请允许访问"+hintWord[perm]+"。"
				var androidHint = "使用该功能需要"+hintWord[perm]+"权限，请前往系统设置开启权限。";
				that.confirm({
					title: '无法使用'+hintWord[perm],
					msg: T.systemType()=="ios"?iosHint:androidHint,
					buttons: ['前往设置', '取消']
				}, function(ret, err) {
					if(1 == ret.buttonIndex){
						that.requestPermission(perm);
					}
				});
				return false;
			}
			return true;
		}
	}
	
	var imageBrowser;
	/**
	 * 打开图片浏览器 2019年9月27日 16:11:36	
	 * https://docs.apicloud.com/Client-API/Func-Ext/imageBrowser 文档地址
	 */
	T.openImageBrowser = function(_param){
		var that = this;
		if (that.isAPICloud()) {
			if(!imageBrowser)
				imageBrowser = api.require('imageBrowser');
			var o = {
				imageUrls: [],
				showList: false,
				activeIndex: 0,
				tapClose: false
			};
			o = that.setNewJSON(o,_param);
			console.error("打开图片集合："+JSON.stringify(o.imageUrls));
			if (that.isAPICloud()) {
				imageBrowser.openImages(o);
			}
		}
	}
	
	var WXPhotoPicker;
	/**
	 * 获取多张图片 
	 */
	T.openUIAlbumBrowser = function(_param,_callback){
		var that = this;
		if (that.isAPICloud()) {
			var WXPhotoPicker = api.require('WXPhotoPicker')
			if (!WXPhotoPicker)
			WXPhotoPicker = api.require('UIAlbumBrowser');
			var o = {
				type: "image",
				max: 8,
				isOpenPreview:false,
				classify:false,
				styles: {mark: {size: 25},nav: {bg: '#000'}}
			};
			o = that.setNewJSON(o,_param);
			WXPhotoPicker.open(o, function( ret ){
				if(_callback){
		 			_callback(ret);
		 		}
			});
		}
	}
	
	/**
	 * getPicture 选择单张图片	
	 * https://docs.apicloud.com/Client-API/api#20
	 */
	T.getPicture = function(_param,_callback){
		var that = this;
		if (that.isAPICloud()) {
			var o = {
				sourceType : "camera",
				encodingType : "jpg",
				mediaValue : "pic",
				targetWidth : 720,
			};
			o = that.setNewJSON(o,_param);
			api.getPicture(o, function(ret, err) {
				if(_callback){
		 			_callback(ret, err);
		 		}
			});
		}
	}
	T.hasSYSPermission = function(_permission){
		var that = this;
		var allPermissions = T.getPrefs('allPermissions').split('|app|');
		for(var i = 0; i < allPermissions.length; i++){
			if(allPermissions[i] == _permission){
				return true;
			}
		}
		return false;
	}
	//储存当前子工程请求URL
	T.saveAjaxMsg = function(_param){
		T.setPrefs(api.appId + '_ajaxUrl',_param.ajaxUrl || "");
		T.setPrefs(api.appId + '_ajaxSiteID',_param.siteID || "");
	}
	//拿当前子工程请求URL
	T.getAjaxUrl = function(_url){
		return T.getPrefs(api.appId + '_ajaxUrl');
	}
	//拿当前子工程请求siteID
	T.getAjaxSiteID = function(_url){
		return T.getPrefs(api.appId + '_ajaxSiteID');
	}
	
	
	/*end*/
	window.T = T;
})(window);