/**
 * 介绍：通用页面引用js 每个页面必须增加 
 * var vmData,vmWatch,vmMethods;
 */
//当前层级
var scripts = $api.domAll("script"), scriptPrefix = "";
for (var i = 0; i < scripts.length; i++) {
	var scriptsSrc = $api.attr(scripts[i], "src");
	if (scriptsSrc && scriptsSrc.indexOf('http') != 0) {
		scriptPrefix = "../../../"+scriptsSrc.split('script')[0];
	}
}
//Vue对象
var vm,general_fs,general_docReader,general_docInteraction;
/**
 * 默认data参数 每个页面都有的参数
 */
var DEFAULT_DATA = {
	safeAreaTop:0,//手机端状态栏高度
	safeAreaBottom:0,//iphoneX 等有底部虚拟条的
	systemType:"",//当前系统 
	pageParam:{},//接收前一个页面的参数
	pageType:"",//页面类型 page或home 默认为page
	footerH:0,//底部高度
	refreshPageSize:0,//返回当前页刷新列表的条数
	dotRefsresh:false,// 返回当前页是否不刷新
	
	appFont: "",//app全局字体
	appFontSize:"",//app全局字体大小
	appTheme:"",//app全局主题色
	
	seachText:"",//搜索词
	seachPlaceholder:"搜索",//搜索提示
	
	
	showSkeleton:true,//是否展示骨架屏
	pageNot:{url:"../../../image/icon_no_data.png",text:"暂无数据"},//页面空时的提示词
	firstAjax:false,//首次网络请求是否成功
	
	tomcatAddress:"http://www.cszysoft.com:9090/",

	careMode:false,//是否启用了关怀模式
};
/**
 * 默认watch参数 每个页面都有 
 */
var DEFAULT_WATCH = {
	//根据引用字体 调用不同的style字体引用	其它字体下载 http://www.foundertype.com/index.php/FindFont/searchFont?keyword=
	"appFont": function (_val) {
		if (!_val) {
			return;
		}
		var fontStyleId = "fontStyle";
		if ($api.byId(fontStyleId)) {//存在的时候先删除
			$api.remove($api.byId(fontStyleId));
		}
		var fontStyle = document.createElement('style');
		fontStyle.id = fontStyleId;

		switch (_val) {
			case "heiti":
				// fontStyle.innerText = "@font-face{font-family: heiti;src: url('" + scriptPrefix + "css/microsoft_yahei.TTF')}";
				break;
			case "traditional":
				fontStyle.innerText = "@font-face{font-family: traditional;src: url('" + scriptPrefix + "css/song_traditional.TTF')}";
				break;
			default:
				fontStyle.innerText = "@font-face{font-family: simplified;src: url('" + scriptPrefix + "css/song_simplified.TTF')}";
				break;
		}
		document.getElementsByTagName('head')[0].appendChild(fontStyle);
		$api.css($api.byId("app"), "font-family:" + this.appFont + ";");
	},
	"appFontSize":function(_val){
		if (!_val) {
			return;
		}
		$api.css($api.dom("body"), this.loadConfiguration());
	},
};
/**
 * 默认methods参数 每个页面都有 
 */
var DEFAULT_METHODS = {
	//默认的初始化方法
	defalutInit:function(){
		var that = this;
		that.changeConfiguration();
		that.appGrayscale();
		$api.removeCls($api.byId("app"), "none");
		if(T.isAPICloud()){
			that.cleanIosDelay();
			that.systemType = T.systemType();
			that.safeAreaTop = api.safeArea.top;//顶部高度
			that.safeAreaBottom = api.safeArea.bottom;//底下导航条高度
			that.pageParam = api.pageParam || {};//页面参数
			that.pageType = that.pageParam.pageType || "page";//页面类型 首页打开 还是页面打开
			that.footerH = Number(that.pageParam.footerH || "0");//打开页面高度
			//接收修改过后的配置 
			T.addEventListener('changeConfiguration',function(ret,err){
				switch(ret.value.type){
					default:that.changeConfiguration();break;
				}
			});
		}
		//因状态栏差异 改变它的颜色 
		setTimeout(function(){
			T.addEventListener('viewappear', function(ret, err){
				that.ifDarkOrLight();
				try{//回到页面就刷新页面
					if(window.loadPage && !that.dotRefsresh){
						that.getData(0);
					}else{
						window.loadPage = true;
					}
				}catch(e){
				}
			});
			var nowWinName = "";
			try{nowWinName = winActualName;}catch(e){nowWinName = "";}
			if(nowWinName && T.frameName()){//有设置主名 并且又是frame的时候 就是在home上的页面
				//我是home下的页面 监听 index页面传来
				T.addEventListener(nowWinName + '-setDarkOrLight', function(ret, err){
					 that.setDarkOrLight();
				});
			}else if(!nowWinName && T.frameName()){//没有主名字	就是子frame
				if(that.pageType=='page' && T.frameName() != "home_footer" && T.frameName() != "checkUpdate"){//页面为frame时 不在首页上 不是底部和更新Frame
					if(that.pageParam.nowIndex?that.pageParam.nowIndex==0:true){//对group来说 只有第1页才能侧滑返回
						T.closeListener();
					}
				}
			}
		},0);
	},
	//判断 当前页面是否有设置主题的功能
	ifDarkOrLight:function(){
		var that = this;
		var nowWinName = "";
		try{nowWinName = winActualName;}catch(e){nowWinName = "";}
		if(nowWinName && !T.frameName()){//如果有顶级名 并且不是frame的 
			var nowHeader = $api.dom("header");
			if(nowHeader){//当前 win有Header就直接设置 没就有 给他发监听
				that.setDarkOrLight();
			}else{
				T.sendEvent({name:nowWinName,extra:{type:"setDarkOrLight"}});
			}
		}
	},
	//当前 页面可以设置主题 再设置
	setDarkOrLight:function(){
		var nowHeader = $api.dom("header");
		var bgC = this.bgC || T.isColorDarkOrLight($api.cssVal(nowHeader,"background-color"));
//		console.error("当前页面背景："+bgC);
		if(bgC == "light" || bgC == "dark"){
			api.setStatusBarStyle({style: bgC == "light"?"dark":"light"});
		}
	},
	//是否全局置灰
	appGrayscale:function(){
		var that = this;
		var appGrayscale = T.getPrefs("appGrayscale") || "0";
		if(appGrayscale == 1){
			$api.css($api.dom("html"),"-webkit-filter: grayscale(100%);-moz-filter: grayscale(100%);-ms-filter: grayscale(100%);-o-filter: grayscale(100%);filter: grayscale(100%);filter: gray;");
		}else{
			$api.css($api.dom("html"),"filter: none;");
		}
	},
	init:function(){},
	//打开书本阅读
	openBook:function(_item,_zy){
		var that = this;
		var myParam = {};
		myParam.pageType = "page";//打开页面方式	home 首页一级模块	 page 作为页面被打开
		myParam.pageOnly = T.getNum();//表示页面唯一参数	必传
		myParam.footerH = 0;//底部按钮高度 传home时会有
		myParam.title = _item.name;//页面名字
		myParam.param = _item;
		if(_zy){
			T.openWin("zyBookReader_win"+myParam.pageOnly,"../../../html/module/api_zyBookReader/zyBookReader_win.html",myParam,true,false);
		}else{
			T.openWin("bookReader_win"+myParam.pageOnly,"../../../html/module/api_bookReader/bookReader_win.html",myParam,true,false);
		}
	},
	//打开书本详细
	openBookDetails:function(_item){
		if(!_item.id){
			return T.toast("书籍为空");
		}
		var myParam = {};
		myParam.pageType = "page";//打开页面方式	home 首页一级模块	 page 作为页面被打开
		myParam.pageOnly = T.getNum();//表示页面唯一参数	必传
		myParam.footerH = 0;//底部按钮高度 传home时会有
		myParam.title = "书籍详情";//页面名字
		myParam.param = _item;
		T.openWin("boolDetails_win"+myParam.pageOnly,"../../../html/module/mo_boolDetails/boolDetails_win.html",myParam,true,false);
	},
	//打开全局搜索页面
	openSearch:function(){
		var myParam = {};
		myParam.pageType = "page";//打开页面方式	home 首页一级模块	 page 作为页面被打开
		myParam.pageOnly = T.getNum();//表示页面唯一参数	必传
		myParam.footerH = 0;//底部按钮高度 传home时会有
		myParam.title = "搜索";//页面名字
		T.openWin("search_win"+myParam.pageOnly,"../../../html/module/mo_search/search_win.html",myParam,true,false,{scrollEnabled:false});
	},
	//书库页面
	openBookStore:function(){
		var myParam = {};
		myParam.pageType = "page";//打开页面方式	home 首页一级模块	 page 作为页面被打开
		myParam.pageOnly = T.getNum();//表示页面唯一参数	必传
		myParam.footerH = 0;//底部按钮高度 传home时会有
		myParam.title = "书库";//页面名字
		T.openWin("bookStore_win"+myParam.pageOnly,"../../../html/module/mo_bookStore/bookStore_win.html",myParam,true,false);
	},
	//书城分类详细页面
	openBookStoreDetails:function(_item){
		var myParam = {};
		myParam.pageType = "page";//打开页面方式	home 首页一级模块	 page 作为页面被打开
		myParam.pageOnly = T.getNum();//表示页面唯一参数	必传
		myParam.footerH = 0;//底部按钮高度 传home时会有
		myParam.title = _item.name;//页面名字
		myParam.param = _item;
		T.openWin("bookStoreDetails_win"+myParam.pageOnly,"../../../html/module/mo_bookStoreDetails/bookStoreDetails_win.html",myParam,true,false);
	},
	//打开笔记页面
	openBookNotes:function(_item){
		var myParam = {};
		myParam.pageType = "page";//打开页面方式	home 首页一级模块	 page 作为页面被打开
		myParam.pageOnly = T.getNum();//表示页面唯一参数	必传
		myParam.footerH = 0;//底部按钮高度 传home时会有
		myParam.title = _item.name || "";//页面名字
		myParam.param = _item;
		myParam.onlyPage = _item.onlyPage || "";
		T.openWin("notes_win"+myParam.pageOnly,"../../../html/module/mo_notes/notes_win.html",myParam,true,false);
	},
	/**
	 * 打开个人资料
	 */
	openPersonalDataDetails:function (_item) {
		var myParam = {};
		myParam.pageType = "page";//打开页面方式	home 首页一级模块	 page 作为页面被打开
		myParam.pageOnly = T.getNum();//表示页面唯一参数	必传
		myParam.footerH = 0;//底部按钮高度 传home时会有
		myParam.title = "";//页面名字_item.name
		myParam.id = _item.id;
		T.openWin("personalData_win" + myParam.pageOnly, "widget://html/module/mo_personalData/personalData_win.html", myParam, true, false);
	},
	//点赞 取消点赞 
	clickLickBtn:function(_item,_type){
		var that = this;
		_item.islike=!_item.islike;
		if(_item.islike){_item.likeNum++;}else{_item.likeNum--;}
		T.ajax({u:T.getAjaxUrl() + "feeling/click/"+(_item.islike?"add":"cansal")+'/'+(_type?_type:'library_book_note')+'?businessId='+_item.noteId},'clickNote'+_item.noteId,function(ret,err){
			if(ret){
			}else{
				T.toast(T.NET_ERR);
				_item.islike = !_item.islike;
				if(_item.islike){_item.likeNum++;}else{_item.likeNum--;}
			}
		},'点赞/取消');
	},
	//消除IOS默认300延时
	cleanIosDelay:function(){
		var that = this;
		setTimeout(function(){
			if(T.systemType() == "ios"){
//				try{FastClick.attach(document.body);}catch(e){console.error(e.message)}
			}
		},10);
	},
	//全局配置
	changeConfiguration:function(){
		var that = this;
		that.appFont = T.getPrefs("appFont") && T.getPrefs("appFont") != "0" ? T.getPrefs("appFont") : "heiti";
		var randomNum = Math.floor(Math.random() * 9), randomText = "";
		for (var i = 0; i < randomNum; i++) {
			randomText += "0";
		}
		that.appFontSize = Number((T.getPrefs("appFontSize") && T.getPrefs("appFontSize") != "0" ? T.getPrefs("appFontSize") : "16") + "." + randomText + "1");
		that.appTheme = T.getPrefs("appTheme") || "#3A77FF";
		that.careMode = parseInt(that.appFontSize) > 16;
	},
	
	//样式加载配置	字体不能改	大小传过来 +几		主题色不能改
	loadConfiguration:function(_changeSize,_max){
		var that = this;
		var changeSize = _changeSize || 0;
		return "font-size:"+((that.appFontSize>_max?_max:that.appFontSize+changeSize)*0.01)+"rem;font-family:"+that.appFont+";";
	},
	//根据配置大小	设置按钮 图片等宽高 +-N
	loadConfigurationSize:function(_changeSize,_who){
		var that = this;
		var changeSize = _changeSize || 0;
		var returnCss = "";
		var cssWidth,cssHeight;
		if(T.isArray(_changeSize)){
			cssWidth = "width:"+((that.appFontSize+(_changeSize[0] || 0))*0.01)+"rem;";
			cssHeight = "height:"+((that.appFontSize+(_changeSize[1] || 0))*0.01)+"rem;";
		}else{
			cssWidth = "width:"+((that.appFontSize+changeSize)*0.01)+"rem;";
			cssHeight = "height:"+((that.appFontSize+changeSize)*0.01)+"rem;";
		}
		if(!_who){
			returnCss = cssWidth + cssHeight;
		}else{
			returnCss = _who == 'w'?cssWidth:cssHeight;
		}
		return returnCss;
	},
	//没有花里胡哨 直接关闭
	closeDirect:function(){
		api.setStatusBarStyle({style:T.getPrefs('systemStyle')});
		api.closeWin({
			animation: {
				type: 'reveal',
				subType: 'from_top',
				duration: 300
			}
		});
	},
	// ================================================================================
	//获取item	只有一层级的时候 会返回 当前index	_i
	getItemForKey:function(_value,_list,_key){
		var that = this;
		for(var i = 0; i < _list.length; i++){
			if(T.isArray(_list[i])){
				for(var j = 0; j < _list[i].length; j++){
					if(_list[i][j][_key||"key"] == _value){
						return _list[i][j];
					}
				}
			}else{
				if(_list[i][_key||"key"] == _value){
					_list[i]['_i'] = i;
					return _list[i];
				}
			}
		}
		return false;
	},
	//在集合中删除第一个参数obj和index都可以或对比字符串	第二个传入集合	第三个为对比key
	delItemForKey:function(_obj,_list,_key){
		var that = this;
		if(!(_obj+""))return;
		if(T.isTargetType(_obj, "number")){
			_list.splice(_obj,1);//删除起始角标	 /	几个数量
		}else{
			var contrastObj = T.isString(_obj)?_obj:_obj[_key||"url"];
			for (var i = 0; i < _list.length; i++) {
				if(_list[i][_key||"url"] == contrastObj)
					_list.splice(i,1);
			}
		}
	},
	//图片共用方法集合 ================================================================================
	//共用缓存方法	item需要一个url参数
	cacheImg:function(_item,_thumbnail,_url){
		var that = this;
		if(_item._imgAjax)
			return;
		_item._imgAjax = true;//是否请求过	有就不再请求
		T.imageCache({
			url: _url || _item.url,
			thumbnail: _thumbnail?true:false
		}, function(ret, err) {
			if (ret.status) {
				_item.url = ret.url;
				_item.showUrl = ret.url;
			}
		});
	},
	//打开预览图片 需要item带url的list 和当前第几页 没传就第1页
	previewImg: function(_list, _index, _key) {
		var that = this;
		var images = [];
		var nowIndex = _index;
		if(T.isArray(_list)){
			for (var i = 0; i < _list.length; i++) {
				images.push(_list[i][_key || "url"]);
			}
		}else{
			images.push(_list[_key || "url"]);
			nowIndex = 0;
		}
		if(T.isAPICloud()){
			T.openImageBrowser({imageUrls:images,activeIndex:nowIndex});
		}else{
			vant.ImagePreview({images: images,startPosition:nowIndex});
		}
	},
	//通用列表页面点击 搜索确定事件
	//	@input 输入中监听			@keyup.enter 回车
	btnSearch:function(_type){
		if(!_type)
			this.$refs["btnSearch"].blur();
		T.goPageTop();
		if(T.isAPICloud()){
			T.refreshHeaderLoading();
		}
	},
	//附件 ================================================================================
	//附件检查是否缓存什么的
	annexCheck: function(_item) {
		var that = this;
		if(!general_fs){
			general_fs = api.require('fs');
		}
		var filePath = _item.url; //取附件地址
		var lastLine = filePath.lastIndexOf("/") + 1;
		var fileName = _item.realName || filePath.substring(lastLine, filePath.length); //取到真实文件名
		var localName = api.fsDir + '/fileCache/' + fileName;
		_item.path = localName;
		_item.iconInfo = that.getFileTypeAttr(fileName.split('.')[1]);
		_item.format = (fileName.split('.')[1] || "unknow").toLowerCase();
//	if (general_fs.existSync({path: localName}).exist) { //判断是否在手机内存中 就拿出来
//		_item.state = 2;
//	}
		_item.state = _item.iconInfo.type == "txt"?general_fs.existSync({path: localName}).exist?2:0:2;//打开文件不需要下载
	},
	//点击附件
	annexClick: function(_item,_id) {
		var that = this;
		_item.id = _id;
		if (_item.bookType == "3" && _item.state != 2) {
			that.annexCache(_item, true);
			return;
		}
		that.annexOpen(_item);
	},
	//开始缓存附件	 item格式 url本地地址路径	state【0未知 1下载中 2下载完成 3下载失败】	schedule下载进度 name显示在界面上的名字
	annexCache: function(_item, _ifOpen) {
		var that = this;
//	if(_item._cacheAjax)
//			return;
//		_item._cacheAjax = true;//是否请求过	有就不再请求
		if (T.isAPICloud()) {
			that.annexCheck(_item);
			if(_item.state == 2){ //判断是否在手机内存中
				_item.schedule = -1;
				if (_ifOpen)
					that.annexOpen(_item);
			} else {
				_item.state = 1;
				_item.schedule = 0;
				api.download({
					url: _item.url,
					savePath: _item.path,
					report: true,
					cache: true,
					allowResume: true
				}, function(ret, err) {
					if (ret) {
						if (ret.state == 1) {
							console.log("缓存这个附件成功:" + JSON.stringify(ret));
							_item.state = 2;
							that.$forceUpdate();
							if (_ifOpen)
								that.annexOpen(_item);
						} else if (ret.state == 2) {
							_item.state = 3;
							T.alert("下载失败，请重试。如多次失败请联系管理员");
							that.$forceUpdate();
						} else if (ret.state == 0) {
							_item.state = 1;
							_item.schedule = ret.percent.toFixed(1);
						}
					} else {
						_item.state = 3;
						T.alert("下载失败，请重试。如多次失败请联系管理员");
						that.$forceUpdate();
					}
				});
			}
		}
	},
	//打开附件
	annexOpen: function(_item) {
		var that = this;
		if (T.isAPICloud()) {
			T.hideProgress();
			if(!_item.id){
				return T.alert("打开了个空");
			}
			if(_item.bookType != "3"){//1为文本书 2为听书 
				that.openBook(_item,true);
				return;
			}
			if(!_item.url){
				return T.alert("打开了个空");
			}
			if(_item.iconInfo.type == "txt"){
				that.openBook(_item);
				return;
			}
			//还是用开网页面来看
			that.openBook(_item,true);
			return;
			if(!general_docReader){
				general_docReader = api.require('docReader');
			}
			if(!general_docInteraction){
				general_docInteraction = api.require('docInteraction');
			}
			if(_item.path){
				general_docReader.open({path: _item.path,autorotation: false},function(ret){
					if(!ret.status){//打不开的时候用这个模块打开
						general_docInteraction.open({path: _item.path},function(ret){
							if(!ret.status){
								api.openApp({
										uri: 'file://' + _item.path
								}, function(ret, err) {
										if (ret) {
										} else {
											alert(JSON.stringify(err));
										}
								});
							}
						});
					}
				});
			}else{
				T.toast('附件打开失败，无地址');
			}
		}
	},
	//获取 文件类型的各种属性
	getFileTypeAttr:function(_type){
		var type = _type || "";
		type = type.toLocaleLowerCase(),iconInfo = {name:"icon_unknown.png",type:"unknown"};
		try {
			if(type.indexOf('.')!= -1)type = type.split('.')[1];
			switch (type) {
				case 'xlsx':case 'xlsm':case 'xlsb':case 'xltx':case 'xltm':case 'xls':case 'xlt':case 'et':case 'csv':case 'uos'://excel格式
					iconInfo.name = "icon_excel.png";
					iconInfo.type = "excel";
					iconInfo.convertType = "61";
					break;
				case 'doc':case 'docx':case 'docm':case 'dotx':case 'dotm':case 'dot':case 'xps':case 'rtf':case 'wps':case 'wpt':case 'uot'://word格式
					iconInfo.name = "icon_word.png";
					iconInfo.type = "word";
					iconInfo.convertType = "61";
					break;
				case 'pdf'://pdf格式
					iconInfo.name = "icon_pdf.png";
					iconInfo.type = "pdf";
					iconInfo.convertType = "20";
					break;
				case 'ppt':case 'pptx':case 'pps':case 'pot':case 'pptm':case 'potx':case 'potm':case 'ppsx':case 'ppsm':case 'ppa':case 'ppam':case 'dps':case 'dpt':case 'uop'://ppt
					iconInfo.name = "icon_ppt.png";
					iconInfo.type = "ppt";
					iconInfo.convertType = "61";
					break;
				case 'bmp':case 'gif':case 'jpg':case 'pic':case 'png':case 'tif':case 'jpeg':case 'jpe':case 'icon':case 'jfif':case 'dib'://图片格式
					iconInfo.name = "icon_pic.png";
					iconInfo.type = "image";
					iconInfo.convertType = "23";
					break;
				case 'txt'://文本
					iconInfo.name = "icon_txt.png";
					iconInfo.type = "txt";
					iconInfo.convertType = "61";
					break;
				case "rar":case "zip":case "7z":case "tar":case "gz":case "jar":case "ios"://压缩格式
					iconInfo.name = "icon_zip.png";
					iconInfo.type = "compression";
					break;
			 	case "mp4":case "avi":case "flv":case "f4v":case "webm":case "m4v":case "mov":case "3gp":case "rm":case "rmvb":case "mkv"://视频格式
			 		iconInfo.name = "icon_mp4.png";
					iconInfo.type = "video";
			 		break;
			 	case "mp3":case "amr":case "pcm":case "wav":case "aiff":case "aac":case "ogg":case "wma":case "flac":case "alac":case "wma":case "cda"://音频格式
			 		iconInfo.name = "icon_mp3.png";
					iconInfo.type = "voice";
			 		break;
			}
		} catch (e) {console.error(e.message)}
		return iconInfo;
	},
};
var nvmData = {},nvmWatch = {},nvmMethods = {};
T.ready(function(){
	try{
		nvmData = T.setNewJSON(DEFAULT_DATA,vmData);
		nvmWatch = T.setNewJSON(DEFAULT_WATCH,vmWatch);
		nvmMethods = T.setNewJSON(DEFAULT_METHODS,vmMethods);
	}catch(e){console.error(e.message)}
	vm = new Vue({
		el: '#app',
		data: nvmData,
		watch:nvmWatch,
		mounted: function () {//页面元素加载完成时调用
			var that = this;
			try{that.defalutInit();}catch(e){console.error(e.message)}
			try{that.init();}catch(e){console.error(e.message)}
		},
		methods: nvmMethods
	});
});
//md5.js
(function($){function safeAdd(x,y){var lsw=(x&65535)+(y&65535);var msw=(x>>16)+(y>>16)+(lsw>>16);return(msw<<16)|(lsw&65535)}function bitRotateLeft(num,cnt){return(num<<cnt)|(num>>>(32-cnt))}function md5cmn(q,a,b,x,s,t){return safeAdd(bitRotateLeft(safeAdd(safeAdd(a,q),safeAdd(x,t)),s),b)}function md5ff(a,b,c,d,x,s,t){return md5cmn((b&c)|(~b&d),a,b,x,s,t)}function md5gg(a,b,c,d,x,s,t){return md5cmn((b&d)|(c&~d),a,b,x,s,t)}function md5hh(a,b,c,d,x,s,t){return md5cmn(b^c^d,a,b,x,s,t)}function md5ii(a,b,c,d,x,s,t){return md5cmn(c^(b|~d),a,b,x,s,t)}function binlMD5(x,len){x[len>>5]|=128<<len%32;x[(((len+64)>>>9)<<4)+14]=len;var i;var olda;var oldb;var oldc;var oldd;var a=1732584193;var b=-271733879;var c=-1732584194;var d=271733878;for(i=0;i<x.length;i+=16){olda=a;oldb=b;oldc=c;oldd=d;a=md5ff(a,b,c,d,x[i],7,-680876936);d=md5ff(d,a,b,c,x[i+1],12,-389564586);c=md5ff(c,d,a,b,x[i+2],17,606105819);b=md5ff(b,c,d,a,x[i+3],22,-1044525330);a=md5ff(a,b,c,d,x[i+4],7,-176418897);d=md5ff(d,a,b,c,x[i+5],12,1200080426);c=md5ff(c,d,a,b,x[i+6],17,-1473231341);b=md5ff(b,c,d,a,x[i+7],22,-45705983);a=md5ff(a,b,c,d,x[i+8],7,1770035416);d=md5ff(d,a,b,c,x[i+9],12,-1958414417);c=md5ff(c,d,a,b,x[i+10],17,-42063);b=md5ff(b,c,d,a,x[i+11],22,-1990404162);a=md5ff(a,b,c,d,x[i+12],7,1804603682);d=md5ff(d,a,b,c,x[i+13],12,-40341101);c=md5ff(c,d,a,b,x[i+14],17,-1502002290);b=md5ff(b,c,d,a,x[i+15],22,1236535329);a=md5gg(a,b,c,d,x[i+1],5,-165796510);d=md5gg(d,a,b,c,x[i+6],9,-1069501632);c=md5gg(c,d,a,b,x[i+11],14,643717713);b=md5gg(b,c,d,a,x[i],20,-373897302);a=md5gg(a,b,c,d,x[i+5],5,-701558691);d=md5gg(d,a,b,c,x[i+10],9,38016083);c=md5gg(c,d,a,b,x[i+15],14,-660478335);b=md5gg(b,c,d,a,x[i+4],20,-405537848);a=md5gg(a,b,c,d,x[i+9],5,568446438);d=md5gg(d,a,b,c,x[i+14],9,-1019803690);c=md5gg(c,d,a,b,x[i+3],14,-187363961);b=md5gg(b,c,d,a,x[i+8],20,1163531501);a=md5gg(a,b,c,d,x[i+13],5,-1444681467);d=md5gg(d,a,b,c,x[i+2],9,-51403784);c=md5gg(c,d,a,b,x[i+7],14,1735328473);b=md5gg(b,c,d,a,x[i+12],20,-1926607734);a=md5hh(a,b,c,d,x[i+5],4,-378558);d=md5hh(d,a,b,c,x[i+8],11,-2022574463);c=md5hh(c,d,a,b,x[i+11],16,1839030562);b=md5hh(b,c,d,a,x[i+14],23,-35309556);a=md5hh(a,b,c,d,x[i+1],4,-1530992060);d=md5hh(d,a,b,c,x[i+4],11,1272893353);c=md5hh(c,d,a,b,x[i+7],16,-155497632);b=md5hh(b,c,d,a,x[i+10],23,-1094730640);a=md5hh(a,b,c,d,x[i+13],4,681279174);d=md5hh(d,a,b,c,x[i],11,-358537222);c=md5hh(c,d,a,b,x[i+3],16,-722521979);b=md5hh(b,c,d,a,x[i+6],23,76029189);a=md5hh(a,b,c,d,x[i+9],4,-640364487);d=md5hh(d,a,b,c,x[i+12],11,-421815835);c=md5hh(c,d,a,b,x[i+15],16,530742520);b=md5hh(b,c,d,a,x[i+2],23,-995338651);a=md5ii(a,b,c,d,x[i],6,-198630844);d=md5ii(d,a,b,c,x[i+7],10,1126891415);c=md5ii(c,d,a,b,x[i+14],15,-1416354905);b=md5ii(b,c,d,a,x[i+5],21,-57434055);a=md5ii(a,b,c,d,x[i+12],6,1700485571);d=md5ii(d,a,b,c,x[i+3],10,-1894986606);c=md5ii(c,d,a,b,x[i+10],15,-1051523);b=md5ii(b,c,d,a,x[i+1],21,-2054922799);a=md5ii(a,b,c,d,x[i+8],6,1873313359);d=md5ii(d,a,b,c,x[i+15],10,-30611744);c=md5ii(c,d,a,b,x[i+6],15,-1560198380);b=md5ii(b,c,d,a,x[i+13],21,1309151649);a=md5ii(a,b,c,d,x[i+4],6,-145523070);d=md5ii(d,a,b,c,x[i+11],10,-1120210379);c=md5ii(c,d,a,b,x[i+2],15,718787259);b=md5ii(b,c,d,a,x[i+9],21,-343485551);a=safeAdd(a,olda);b=safeAdd(b,oldb);c=safeAdd(c,oldc);d=safeAdd(d,oldd)}return[a,b,c,d]}function binl2rstr(input){var i;var output="";var length32=input.length*32;for(i=0;i<length32;i+=8){output+=String.fromCharCode((input[i>>5]>>>i%32)&255)}return output}function rstr2binl(input){var i;var output=[];output[(input.length>>2)-1]=undefined;for(i=0;i<output.length;i+=1){output[i]=0}var length8=input.length*8;for(i=0;i<length8;i+=8){output[i>>5]|=(input.charCodeAt(i/8)&255)<<i%32}return output}function rstrMD5(s){return binl2rstr(binlMD5(rstr2binl(s),s.length*8))}function rstrHMACMD5(key,data){var i;var bkey=rstr2binl(key);var ipad=[];var opad=[];var hash;ipad[15]=opad[15]=undefined;if(bkey.length>16){bkey=binlMD5(bkey,key.length*8)}for(i=0;i<16;i+=1){ipad[i]=bkey[i]^909522486;opad[i]=bkey[i]^1549556828}hash=binlMD5(ipad.concat(rstr2binl(data)),512+data.length*8);return binl2rstr(binlMD5(opad.concat(hash),512+128))}function rstr2hex(input){var hexTab="0123456789abcdef";var output="";var x;var i;for(i=0;i<input.length;i+=1){x=input.charCodeAt(i);output+=hexTab.charAt((x>>>4)&15)+hexTab.charAt(x&15)}return output}function str2rstrUTF8(input){return unescape(encodeURIComponent(input))}function rawMD5(s){return rstrMD5(str2rstrUTF8(s))}function hexMD5(s){return rstr2hex(rawMD5(s))}function rawHMACMD5(k,d){return rstrHMACMD5(str2rstrUTF8(k),str2rstrUTF8(d))}function hexHMACMD5(k,d){return rstr2hex(rawHMACMD5(k,d))}function md5(string,key,raw){if(!key){if(!raw){return hexMD5(string)}return rawMD5(string)}if(!raw){return hexHMACMD5(key,string)}return rawHMACMD5(key,string)}if(typeof define==="function"&&define.amd){define(function(){return md5})}else{if(typeof module==="object"&&module.exports){module.exports=md5}else{$.md5=md5}}})(this);
// 签名算法
function zyBookSign(params) {
	var encrypt = md5(params).substr(6, 18);
	return md5(encrypt).substr(10, 16);
}

//var bookUrl = "https://s.zhangyue.com/read?bid=10880251&cid=1&";
//var addUrl = "appId=41ec83c2&rentId=103053&timestamp="+(Date.parse(new Date()).toString().substr(0,10))+"&userId=1";
//var signUrl = "&sign=" + zyBookSign(addUrl);
//var allUrl = bookUrl + addUrl + signUrl;
//console.log(allUrl);
