(function(window){
		var u = {};
		var uzStorage = function(){
				var ls = window.localStorage;
				return ls;
		};
		u.trim = function(str){
				if(String.prototype.trim){
						return str == null ? "" : String.prototype.trim.call(str);
				}else{
						return str.replace(/(^\s*)|(\s*$)/g, "");
				}
		};
		u.trimAll = function(str){
				return str.replace(/\s*/g,'');
		};
		u.isElement = function(obj){
				return !!(obj && obj.nodeType == 1);
		};
		u.dom = function(el, selector){
				if(arguments.length === 1 && typeof arguments[0] == 'string'){
						if(document.querySelector){
								return document.querySelector(arguments[0]);
						}
				}else if(arguments.length === 2){
						if(el.querySelector){
								return el.querySelector(selector);
						}
				}
		};
		u.domAll = function(el, selector){
				if(arguments.length === 1 && typeof arguments[0] == 'string'){
						if(document.querySelectorAll){
								return document.querySelectorAll(arguments[0]);
						}
				}else if(arguments.length === 2){
						if(el.querySelectorAll){
								return el.querySelectorAll(selector);
						}
				}
		};
		u.byId = function(id){
				return document.getElementById(id);
		};
		u.remove = function(el){
				if(el && el.parentNode){
						el.parentNode.removeChild(el);
				}
		};
		u.attr = function(el, name, value){
				if(!u.isElement(el)){
						console.warn('$api.attr Function need el param, el param must be DOM Element');
						return;
				}
				if(arguments.length == 2){
						return el.getAttribute(name);
				}else if(arguments.length == 3){
						el.setAttribute(name, value);
						return el;
				}
		};
		u.removeAttr = function(el, name){
				if(!u.isElement(el)){
						console.warn('$api.removeAttr Function need el param, el param must be DOM Element');
						return;
				}
				if(arguments.length === 2){
						el.removeAttribute(name);
				}
		};
		u.hasCls = function(el, cls){
				if(!u.isElement(el)){
						console.warn('$api.hasCls Function need el param, el param must be DOM Element');
						return;
				}
				if(el.className.indexOf(cls) > -1){
						return true;
				}else{
						return false;
				}
		};
		u.addCls = function(el, cls){
				if(!u.isElement(el)){
						console.warn('$api.addCls Function need el param, el param must be DOM Element');
						return;
				}
				if('classList' in el){
						el.classList.add(cls);
				}else{
						var preCls = el.className;
						var newCls = preCls +' '+ cls;
						el.className = newCls;
				}
				return el;
		};
		u.removeCls = function(el, cls){
				if(!u.isElement(el)){
						console.warn('$api.removeCls Function need el param, el param must be DOM Element');
						return;
				}
				if('classList' in el){
						el.classList.remove(cls);
				}else{
						var preCls = el.className;
						var newCls = preCls.replace(cls, '');
						el.className = newCls;
				}
				return el;
		};
		u.offset = function(el){
				if(!u.isElement(el)){
						console.warn('$api.offset Function need el param, el param must be DOM Element');
						return;
				}
				var sl = Math.max(document.documentElement.scrollLeft, document.body.scrollLeft);
				var st = Math.max(document.documentElement.scrollTop, document.body.scrollTop);
				var rect = el.getBoundingClientRect();
				return {
						l: rect.left + sl,
						t: rect.top + st,
						w: el.offsetWidth,
						h: el.offsetHeight
				};
		};
		u.css = function(el, css){
				if(!u.isElement(el)){
						console.warn('$api.css Function need el param, el param must be DOM Element');
						return;
				}
				if(typeof css == 'string' && css.indexOf(':') > 0){
						el.style && (el.style.cssText += ';' + css);
				}
		};
		u.cssVal = function(el, prop){
				if(!u.isElement(el)){
						console.warn('$api.cssVal Function need el param, el param must be DOM Element');
						return;
				}
				if(arguments.length === 2){
						var computedStyle = window.getComputedStyle(el, null);
						return computedStyle.getPropertyValue(prop);
				}
		};
		u.jsonToStr = function(json){
				if(typeof json === 'object'){
						return JSON && JSON.stringify(json);
				}
		};
		u.strToJson = function(str){
				if(typeof str === 'string'){
						return JSON && JSON.parse(str);
				}
		};
		u.setStorage = function(key, value){
				if(arguments.length === 2){
						var v = value;
						if(typeof v == 'object'){
								v = JSON.stringify(v);
								v = 'obj-'+ v;
						}else{
								v = 'str-'+ v;
						}
						var ls = uzStorage();
						if(ls){
								ls.setItem(key, v);
						}
				}
		};
		u.getStorage = function(key){
				var ls = uzStorage();
				if(ls){
						var v = ls.getItem(key);
						if(!v){return;}
						if(v.indexOf('obj-') === 0){
								v = v.slice(4);
								return JSON.parse(v);
						}else if(v.indexOf('str-') === 0){
								return v.slice(4);
						}
				}
		};
		u.rmStorage = function(key){
				var ls = uzStorage();
				if(ls && key){
						ls.removeItem(key);
				}
		};
		u.clearStorage = function(){
				var ls = uzStorage();
				if(ls){
						ls.clear();
				}
		};
		u.fixStatusBar = function(el){
				if(!u.isElement(el)){
						console.warn('$api.fixStatusBar Function need el param, el param must be DOM Element');
						return 0;
				}
				el.style.paddingTop = api.safeArea.top + 'px';
				return el.offsetHeight;
		};
		u.fixTabBar = function(el){
				if(!u.isElement(el)){
						console.warn('$api.fixTabBar Function need el param, el param must be DOM Element');
						return 0;
				}
				el.style.paddingBottom = api.safeArea.bottom + 'px';
				return el.offsetHeight;
		};
		window.$api = u;
})(window);

(function(window){
	var zyUrl = {}; 
	/*start*/
	/**
	 * 返回系统主要url 例：http://www.cszysoft.com:8081/zyrdzx3.0zx/
	 */
	zyUrl.getAppUrl = function() {
			return T.getPrefs("SYS_app_url") || T.getPrefs(api.appId + '_ajaxUrl');
	};
	/**
	 * 返回用户中心url 例：http://www.cszysoft.com:8081/zyrdzx3.0zx/
	 */
	zyUrl.getUserCenterUrl = function() {
			return T.getPrefs("SYS_userCenter_url");
	};
	/**
	 * 返回融云接口地址 
	 */
	zyUrl.getTomcatAddress = function() {
			return T.getPrefs("SYS_tomcatAddress");
	};
	/**
	 * 返回大数据 接口地址 
	 */
	zyUrl.getBigDataAddress = function() {
			return T.getPrefs("bigDataAddress");
	};
	/**
	 * 返回聊天前缀	例：yszx
	 */
	zyUrl.getChatHeader = function() {
			return T.getPrefs("SYS_chatHeader");
	};
	/**
	 * 返回地区id	例：430000
	 */
	zyUrl.getSiteID = function() {
			return T.getPrefs("SYS_SiteID") || T.getPrefs(api.appId + '_ajaxSiteID');
	};
	/**
	 * 返回类别	1人大	2政协
	 */
	zyUrl.getSoftID = function() {
			return T.getPrefs("SYS_SoftID");
	};
	/*end*/
	window.zyUrl = zyUrl;
})(window);

(function (doc, win) {
	var docEl = doc.documentElement,
	resizeEvt = 'orientationchange' in window ? 'orientationchange' : 'resize',
	recalc = function () {
		var clientWidth = docEl.clientWidth;
		if(clientWidth > 480){
			clientWidth = 480;
		}
		if (!clientWidth) return;
		docEl.style.fontSize = 100 * (clientWidth / 360) + 'px';
	};
	if (!doc.addEventListener) return;
	win.addEventListener(resizeEvt, recalc, false);
	doc.addEventListener('DOMContentLoaded', recalc, false);
})(document, window);

Array.prototype.indexOf = function(val) {
	for (var i = 0; i < this.length; i++) {
		if (this[i] == val) return i;
	}
	return -1;
};

Array.prototype.remove = function(val) {
	var index = this.indexOf(val);
	if (index > -1) {
		this.splice(index, 1);
	}
};
