/**
 * 介绍：通用页面引用js 每个页面必须增加 
 * var vmData,vmWatch,vmMethods;
 */
//当前层级
var scripts = $api.domAll("script"), scriptPrefix = "";
for (var i = 0; i < scripts.length; i++) {
	var scriptsSrc = $api.attr(scripts[i], "src");
	if (scriptsSrc && scriptsSrc.indexOf('http') != 0) {
		scriptPrefix = scriptsSrc.split('script')[0];
	}
}
loadjscssfile(scriptPrefix + "../../script/myjs.js","js");
loadjscssfile(scriptPrefix + "css/icon/iconfont.css","css");//引入字体文件
//动态引用文件
function loadjscssfile(filename,filetype){
	var fileref = null;
	if(filetype == "js"){
		fileref = document.createElement('script');
		fileref.setAttribute("type","text/javascript");
		fileref.setAttribute("src",filename);
	}else if(filetype == "css"){
		fileref = document.createElement('link');
		fileref.setAttribute("rel","stylesheet");
		fileref.setAttribute("type","text/css");
		fileref.setAttribute("href",filename);
	}
	if(typeof fileref != "undefined"){
		document.getElementsByTagName('head')[0].appendChild(fileref);
	}
}
//Vue对象
var vm, general_fs, general_db, general_imageTools, general_trans, general_colorGain;
var waitImgList = [],inImgList = [], threadList = ["", "", "", "", "", "", "", "", "", "", "", "", "", ""];//等待缓存集合，正在缓存集合，缓存图片线程池
/**
 * 默认data参数 每个页面都有的参数
 */
var DEFAULT_DATA = {
	safeAreaTop: 0,//手机端状态栏高度
	safeAreaBottom: 0,//iphoneX 等有底部虚拟条的
	pageParam: {},//接收前一个页面的参数
	pageType: "",//页面类型 page或home 默认为page
	systemType: "",//系统 类型
	systemVersion: "",//手机平台的系统版本 例如：安卓6.0  苹果9.0
	appName: "",//应用名字
	refreshPageSize: 0,//返回当前页刷新列表的条数
	dotRefsresh: false,// 返回当前页是否不刷新
	showSkeleton: true,//是否展示骨架屏

	appFont: "",//app全局字体
	appFontSize: "",//app全局字体大小
	appTheme: "",//app全局主题色
	headTheme: "",//head全局主题色

	seachText: "",//搜索词
	seachPlaceholder: "搜索关键词",//搜索提示

	firstAjax: false,//首次网络请求是否成功
	dotCloseListener: false,//当前页面不要划动返回
	hasCloseListener: false,//不管其它页面 直接添加关闭监听

	careMode:false,//是否启用了关怀模式

	pageNot: {
		type: 0, url: "", text: "", summary: "", hasBtn: true, data: [
			{ url: scriptPrefix + "images/errMsg1.png", text: "暂无数据~", summary: "您还没有相关的信息哦！" },
			{ url: scriptPrefix + "images/errMsg2.png", text: "您的网络不稳定哦，请刷新重试~", summary: "" },
			{ url: scriptPrefix + "images/errMsg3.png", text: "抱歉，找不到页面内容了~", summary: "" },
			{ url: scriptPrefix + "images/errMsg1.png", text: "暂无权限", summary: "您还没有权限查看" },
			{ url: scriptPrefix + "images/errMsg1.png", text: "图片加载失败", summary: "请刷新试试看吧~" },
			{ url: scriptPrefix + "images/errMsg1.png", text: "暂无消息", summary: "您还没有收到消息哦~" },
		]
	},//页面空时的提示词

	userId:"",//当前用户id
	userName:"",//当前用户名字
	userImg:"",//当前用户头像
	defaultBgColor:"",//header第一帧颜色 
	keyboardHeight:0,//键盘弹出高度

	systemtTypeIsPlatform:false,//系统类型是否是平台版
};
/**
 * 默认watch参数 每个页面都有 
 */
var DEFAULT_WATCH = {
	//根据引用字体 调用不同的style字体引用	其它字体下载 http://www.foundertype.com/index.php/FindFont/searchFont?keyword=
	"appFont": function (_val) {
		if (!_val) {
			return;
		}
		var fontStyleId = "fontStyle";
		if ($api.byId(fontStyleId)) {//存在的时候先删除
			$api.remove($api.byId(fontStyleId));
		}
		var fontStyle = document.createElement('style');
		fontStyle.id = fontStyleId;
		switch (_val) {
			case "heiti":
				// fontStyle.innerText = "@font-face{font-family: heiti;src: url('" + scriptPrefix + "css/microsoft_yahei.TTF')}";
				break;
			case "traditional":
				fontStyle.innerText = "@font-face{font-family: traditional;src: url('" + scriptPrefix + "css/song_traditional.TTF')}";
				break;
			default:
				fontStyle.innerText = "@font-face{font-family: simplified;src: url('" + scriptPrefix + "css/song_simplified.TTF')}";
				break;
		}
		document.getElementsByTagName('head')[0].appendChild(fontStyle);
		$api.css($api.byId("app"), "font-family:" + this.appFont + ";");
	},
	"appFontSize":function(_val){
		if (!_val) {
			return;
		}
		$api.css($api.dom("body"), this.loadConfiguration());
	},
};
/**
 * 默认methods参数 每个页面都有 
 */
var DEFAULT_METHODS = {
	//默认的初始化方法
	defalutInit: function () {
		var that = this;
		$api.removeCls($api.byId("app"), "none");
		if (T.isAPICloud()) {
			general_fs = api.require('fs');
			general_db = api.require('db');
			general_imageTools = api.require('imageTools');
			general_trans = api.require('trans');
			general_colorGain = api.require('colorGain');
			that.cleanIosDelay();
			that.systemType = api.systemType;
			that.appName = api.appName;
			that.systemVersion = api.systemVersion;
			that.safeAreaTop = api.safeArea.top;//顶部高度
			that.safeAreaBottom = api.safeArea.bottom;//底下导航条高度
			that.pageParam = api.pageParam || {};//页面参数
			that.pageType = that.pageParam.pageType || "page";//页面类型 首页打开 还是页面打开
			that.userId = T.getPrefs("Sys_UserID") || "";
			that.userName = T.getPrefs("Sys_UserName") || "";
			that.userImg = T.getPrefs("Sys_AppPhoto") || "";
			that.initOther();
			//初始化完成的监听
			T.addEventListener("index_init_ok", function (ret, err) {
				that.initOther();
			});
			//接收修改过后的配置 
			T.addEventListener('changeConfiguration', function (ret, err) {
				that.changeConfiguration();
				if(window.dealWithCon && that.content){//有内容 并且内容处理过
					that.content = that.dealWithCon(that.content || "");//内容
				}
				T.sendEvent({ name: 'changeConfigurationSize' });//发送给需要改变的地方 
			});
			//任何页面打开之后	都调整首页层级 完美
			T.sendEvent({ name: 'home_page', extra: { type: "bringFrame", nName: api.frameName } });
			//弹出 收起键盘监听
			T.addEventListener('keyboardshow',function(ret){
				that.keyboardHeight = ret.h;
			});
			T.addEventListener('keyboardhide',function(){
				that.keyboardHeight = 0;
			});
		}
		that.changeConfiguration();
		that.appGrayscale();
		//因状态栏差异 改变它的颜色 
		setTimeout(function () {
			T.addEventListener('viewappear', function (ret, err) {
				that.ifDarkOrLight();
				try {//回到页面就刷新页面
					if (window.loadPage && !that.dotRefsresh) {
						that.getData(0);
					} else {
						window.loadPage = true;
					}
				} catch (e) {
				}
				var nViewappearType = "";
				try { nViewappearType = viewappearType; } catch (e) { nViewappearType = ""; }
				if (nViewappearType == "1") {//在home_page上 回到这里刷新
					T.sendEvent({ name: 'menu_msg' });
					if (window.floatButtonShow) {//如果悬浮球有打开 就展示 出来
						T.sendEvent({ name: 'home_page', extra: { type: "openSmallAssistant" } });
					}
				} else if (nViewappearType == "2") {//在 scan_win 防止可能突然没框	再 Window 显示到屏幕时 再打开一次
					if (!window.firstOpen) {
						window.firstOpen = true;
					} else {
						that.openFNScanner();
					}
				}
			});
			var nowWinName = "";
			try { nowWinName = winActualName; } catch (e) { nowWinName = ""; }
			if (nowWinName && T.frameName() && !that.pageParam.headerH) {//有设置主名 并且又是frame的时候 就是在home上的页面	 !that.pageParam.headerH是针对单页面时又为别人的子页面 就不加监听
				//我是home下的页面 监听 index页面传来
				T.addEventListener(nowWinName + '-setDarkOrLight', function (ret, err) {
					that.setDarkOrLight();
				});
			} else if ((!nowWinName && T.frameName()) || that.hasCloseListener) {//没有主名字	就是子frame
				if (that.pageType=='page' && (!that.dotCloseListener || that.hasCloseListener)) {//页面为frame时 不在首页上 不是底部和更新Frame
					if (that.pageParam.nowIndex ? that.pageParam.nowIndex == 0 : true) {//对group来说 只有第1页才能侧滑返回
						T.closeListener();
					}
				}
			}
		}, 10);
	},
	//初始化其它配置
	initOther:function(){
		var that = this;
		that.systemtTypeIsPlatform = T.getPrefs("systemtTypeIsPlatform") == "true";//系统类型是否是平台版
	},
	//判断 当前页面是否有设置主题的功能
	ifDarkOrLight: function () {
		var that = this;
		var nowWinName = "";
		try { nowWinName = winActualName; } catch (e) { nowWinName = ""; }
		if ((nowWinName && !T.frameName()) || T.frameName() == "login_frame") {//如果有顶级名 并且不是frame的 
			var nowHeader = $api.dom("header");
			if (nowHeader) {//当前 win有Header就直接设置 没就有 给他发监听
				that.setDarkOrLight();
			} else {
				T.sendEvent({ name: nowWinName, extra: { type: "setDarkOrLight" } });
			}
		}
	},
	//当前 页面可以设置主题 再设置
	setDarkOrLight: function () {
		var that = this;
		var nowHeader = $api.dom("header");
		var bgC = T.isColorDarkOrLight(that.defaultBgColor || $api.attr(nowHeader, "defaultColor") || $api.cssVal(nowHeader, "background-color") || that.headTheme);//header如果有背景
		//		console.error(api.winName+'-'+api.frameName+"当前页面背景："+bgC);
		if (bgC == "light" || bgC == "dark") {
			api.setStatusBarStyle({ style: bgC == "light" ? "dark" : "light", color: "rgba(0,0,0,0)" });
		}
	},
	//是否全局置灰
	appGrayscale: function () {
		var that = this;
		var appGrayscale = T.getPrefs("appGrayscale") || "0";
		if (appGrayscale == 1) {
			$api.css($api.dom("html"), "-webkit-filter: grayscale(100%);-moz-filter: grayscale(100%);-ms-filter: grayscale(100%);-o-filter: grayscale(100%);filter: grayscale(100%);filter: gray;");
		} else {
			$api.css($api.dom("html"), "filter: none;");
		}
	},
	//获取当前主题色相对应前景色
	getHeadThemeRelatively: function (isTheme) {
		var that = this;
		if (isTheme) {
			return '#ffffff';
		} else {
			if (that.headTheme) {
				return T.isColorDarkOrLight(that.headTheme) == "light" ? '#333' : that.appTheme;
			}
		}
	},
	init: function () { },
	//消除IOS默认300延时
	cleanIosDelay: function () { },
	//全局配置
	changeConfiguration: function () {
		var that = this;
		that.appFont = (T.getPrefs("appFont") && T.getPrefs("appFont") != "0") ? T.getPrefs("appFont") : "heiti";
		that.appFontSize = Number((T.getPrefs("appFontSize") && T.getPrefs("appFontSize") != "0" ? T.getPrefs("appFontSize") : "16"));
		that.appTheme = that.pageParam.appTheme || (T.getPrefs("appTheme") && T.getPrefs("appTheme") != "0" ? T.getPrefs("appTheme") : (SYS_IF_ZX?"#3088FE":"#C61414"));
		that.headTheme = T.getPrefs("headTheme") || "#fff";
		that.careMode = parseInt(that.appFontSize) > 16;
	},
	//样式加载配置	字体不能改	大小传过来 +几		主题色不能改
	loadConfiguration: function (_changeSize, _max) {
		return loadConfiguration(_changeSize, _max);
	},
	//根据配置大小	设置按钮 图片等宽高 +-N
	loadConfigurationSize: function (_changeSize, _who) {
		return loadConfigurationSize(_changeSize, _who);
	},
	//通用列表页面点击 搜索确定事件
	//	@input 输入中监听			@keyup.enter 回车
	btnSearch: function (_type) {
		if (!_type)
			this.$refs["btnSearch"].blur();
		T.goPageTop();
		if (T.isAPICloud()) {
			T.refreshHeaderLoading();
			setTimeout(function () {
				T.refreshHeaderLoadDone();
			}, 2000);
		}
	},
	// ================================================================================
	//获取item	只有一层级的时候 会返回 当前index	_i
	getItemForKey: function (_value, _list, _key, _child) {
		var that = this;
		var hasChild = false;
		for (var i = 0; i < _list.length; i++) {
			if (T.isArray(_list[i])) {
				hasChild = true;
				var result = that.getItemForKey(_value, _list[i], _key, true);
				if (result)//看对象里面有没有结果	没有就不管
					return result;
			} else {
				if ((T.isString(_list[i]) ? _list[i] : _list[i][_key || "key"]) == _value) {
					if (!T.isString(_list[i]))
						_list[i]['_i'] = i;
					return _list[i];
				}
			}
		}
		if (!_child && !hasChild)
			return false;
	},
	//在集合中删除第一个参数obj和index都可以或对比字符串	第二个传入集合	第三个为对比key
	delItemForKey: function (_obj, _list, _key) {
		var that = this;
		if (!T.isParameters(_obj)) return;
		if (T.isTargetType(_obj, 'number')) {//如果是数字 
			_list.splice(_obj, 1);//删除起始角标	 /	几个数量
		} else {
			var contrastObj = T.isString(_obj) ? _obj : _obj[_key || "url"];
			for (var i = 0; i < _list.length; i++) {
				if ((T.isString(_list[i]) ? _list[i] : _list[i][_key || "url"]) == contrastObj)
					_list.splice(i, 1);
			}
		}
	},
	//图片共用方法集合 ================================================================================
	//共用缓存方法	item需要一个url参数
	cacheImg: function (_item, _thumbnail, _url, _priority) {
		cacheImg(this,_item, _thumbnail, _url, _priority);
	},
	//计算图片是否需要高斯模糊
	calculateProportion:function(_item){
		calculateProportion(this,_item);
	},
	//打开预览图片 需要item带url的list 和当前第几页 没传就第1页
	previewImg: function (_list, _index, _key) {
		var that = this;
		var images = [];
		var nowIndex = _index;
		if (T.isArray(_list)) {
			for (var i = 0; i < _list.length; i++) {
				images.push(_list[i][_key || "url"]);
			}
		} else {
			images.push(_list[_key || "url"]);
			nowIndex = 0;
		}
		if (T.isAPICloud()) {
			T.openImageBrowser({ imageUrls: images, activeIndex: nowIndex });
		} else {
			vant.ImagePreview({ images: images, startPosition: nowIndex });
		}
	},
	//文字共用方法集合 ================================================================================
	//处理正文中的原生格式问题 转换成html格式
	dealWithCon: function (_content) {
		var that = this;
		window.dealWithCon = true;
		//抓到的数据 可能没得标签
		var expText = _content || "";
		//转换格式之后还正文还没得 标签 先加一个
		var expLength = expText.match(/<.*?>/g) || [];
		if (expLength.length < 2) {
			expText = '<p>' + expText + '</p>';
		}
		//		//再匹配标签中的正文
		var strRegex = '[^\>?]+[\<]';
		var regex = new RegExp(strRegex, "gi");//匹配所有非标签中的字符	g不停止	 i忽略大小写
		if (regex.test(expText)) {//如果有标签内容	(肯定有)
			expText = expText.replace(regex, function (m) {
				return m.replace(/&amp;/g, "&").replace(/ /g, "&nbsp;").replace(/\n/g, "<br />");//将标签中的	\n换成br 空格 抱成 nbsp
			});
		}
		//默认去除所有标签
		if (!T.getPrefs("appDetailsStyle")) {
			//文件资料里见鬼	有style 先删掉
			expText = expText.replace(/<style(.*?)<\/style>/gi, '');
			expText = expText.replace(/<link(.*?)<\/link>/gi, '');//引入link删除
			expText = expText.replace(/<script(.*?)<\/script>/gi, '');//引入script删除
			expText = expText.replace(/style\s*=(['\"\s]?)[^'\"]*?\1/gi, '').replace(/&nbsp;/g,'').replace(/　/g,'');//删除所有行内样式	还有一些多余的空格 
			expText = expText.replace(/<(?!\/?video|\/?p|\/?img|\/?br|\/?a\/?.+?>)[^<>]*>/gi, '');//保留 p	img video 去除其它标签
			expText = expText.replace(/<(p).*?>/gi, '<p style="text-indent:2em;line-height:1.8;color:#444;font-size:' + ((that.appFontSize + 2) * 0.01) + 'rem;">');//修改p默认样式 padding-bottom:0.15rem;
		}
		//		console.error(expText);
		return expText;
	},
	//处理原生格式为html格式	一般用于提交时 
	conversionRichText: function (value) {
		if (!value || !T.isString(value)) return value;
		var textList = value.split('\n');
		var str = '';
		for (var i = 0; i < textList.length; i++) {
			var addText = textList[i].replace(/&amp;/g, "&").replace(/ /g, "&nbsp;");
			if (addText) {
				str = str + '<p>' + addText + '</p>';
			}
		}
		return str;
	},
	//输入框中回显 html编辑 去除富文本标签格式，返回文本	参数一：文本，参数二：是否保留空格，参数三：是否保留换行， 参数四：是否段落缩进（当参数三为真时有效），参数五：去除标签是否换行
	clearRichText: function (value, space, wrap, indent, tab) {
		if (!T.isString(value) || !value) return value;
		value = value.replace(/&amp;/g, "&");//坑爹的后台管理了 & 符号
		// 空格处理
		if (space) {
			value = value.replace(/(&nbsp;)/g, " ");
		} else {
			value = value.replace(/(&nbsp;)/g, "");
			value = value.replace(/ /g, "");
		}
		// 换行处理
		if (wrap) {
			if (indent) {
				value = value.replace(/<br\/?[^>]*>/g, "\n			");
			} else {
				value = value.replace(/<br\/?[^>]*>/g, "\n");
			}
		} else {
			value = value.replace(/(\n)/g, ""); // 换行
			value = value.replace(/(\t)/g, ""); // tab水平制表
			value = value.replace(/(\r)/g, ""); // 回车
		}
		if (!space && !wrap) value = value.replace(/\s*/g, ""); // 空白和换行
		if (tab) value = value.replace(/<\/[p|div|h1|h2|h3|h4|h5|h6]>/g, "\n			");
		value = value.replace(/<\/?[^>]*>/g, "");
		// value = value.replace(/(&lt;)\/?[^(&gt;)]*(&gt)/g, "")
		if (wrap && indent) value = '			' + value;
		return value;
	},
	//附件共用方法集合 ================================================================================
	//执行上传附件	item格式 uploadType另一种上传格式 url本地地址路径	uploadUrl上传后的地址 uploadId上传后的id	state状态【1上传中2完成3失败】	 module上传类型具体看文档
	annexUpload: function (_item, _uploadType) {
		var that = this;
		if (_item._fileAjax || _item.module == '-noUpload')//有传过 或者明确不传
			return;
		_item._fileAjax = true;//是否请求过	有就不再请求
		if (T.isAPICloud()) {
			_item.state = 1;
			var url = zyUrl.getAppUrl() + "attachment/uploadFile";
			var files = { attachment: _item.url };
			if (_uploadType == "uploadimg") {
				url = zyUrl.getAppUrl() + "file/uploadimg";
				files = { file: _item.url };
			}
			T.ajax({ u: url, paramData: {} }, _item.url, function (ret, err) {
				if (ret) {
					if (_uploadType == "uploadimg") {
						var data = ret.data || {};
						var fullUrl = data.fullUrl || "";
						if (!fullUrl) {
							_item.state = 3;
							_item.error = ret.errmsg || "";
						} else {
							_item.state = 2;
							_item.uploadUrl = fullUrl || "";
							_item.uploadId = data.shortName || "";
						}
					}else{
						var data = ret?ret.data||[]:[];
						var dataLength = data ? data.length : 0;
						if (!data || !T.isArray(data) || dataLength == 0) {
							_item.state = 3;
							_item.error = ret.errmsg || "";
						} else {
							var info = data[0];
							_item.state = 2;
							_item.uploadUrl = info.filePath || "";
							_item.uploadId = info.id || "";
						}
					}
				} else {
					_item.state = 3;
				}
				that.$forceUpdate();
			}, "上传附件", "post", {
				values: {
					"module": _item.module,
					"siteId": zyUrl.getSiteID()
				},
				files: files
			});
		}
	},
	//附件异常提示
	annexError: function (_item) {
		var that = this;
		if (_item.state == 1) {
			T.toast('上传中');
		} else if (_item.state == 2) {
			T.toast('上传成功');
		} else if (_item.state == 3) {
			T.toast(_item.error);
		} else {
			T.toast('准备上传中');
		}
	},
	//返回提示文字		state【0未知 1下载中 2下载完成 3下载失败】
	annexShowHint: function (_item) {
		var that = this;
		var hint = "";
		switch (_item.state) {
			case 1:
				hint = _item.schedule >= 0 ? '【缓存' + _item.schedule + '%】' : '';
				break;
			case 3:
				hint = "【缓存失败】";
				break;
		}
		return hint;
	},
	//附件检查是否缓存什么的
	annexCheck: function (_item) {
		var that = this;
		var filePath = _item.url || _item.filePath; //取附件地址
		var lastLine = filePath.lastIndexOf("/") + 1;
		var fileName = _item.name || filePath.substring(lastLine, filePath.length); //取到真实文件名
		var localName = api.fsDir + '/fileCache/' + fileName;
		_item.path = localName;
		_item.iconInfo = that.getFileTypeAttr(fileName.split('.')[fileName.split('.').length - 1]);
		_item.schedule = -1;
		//	_item.state = general_fs.existSync({path: localName}).exist?2:0;
		_item.state = 2;//打开文件不需要下载
	},
	//点击附件
	annexClick: function (_item, _toast) {
		var that = this;
		that.annexCheck(_item);//怕附件缓存后被 删除了 打开时预检测一次
		if (_toast)
			T.showProgress("打开中");
		if (_item.state != 2) {
			_item._cacheAjax = false;
			that.annexCache(_item, true);
			return;
		}
		that.annexOpen(_item);
	},
	//开始缓存附件	 item格式 url本地地址路径	state【0未知 1下载中 2下载完成 3下载失败】	schedule下载进度 name显示在界面上的名字
	annexCache: function (_item, _ifOpen, _cache) {
		var that = this;
		if (_item._cacheAjax)
			return;
		_item._cacheAjax = true;//是否请求过	有就不再请求
		if(!_cache){
			//现在都不用请求了
			_item.state = 2;
			return;
		}
		if (T.isAPICloud()) {
			var filePath = _item.url || _item.filePath; //取附件地址
			var lastLine = filePath.lastIndexOf("/") + 1;
			var fileName = _item.name || filePath.substring(lastLine, filePath.length); //取到真实文件名
			var localName = api.fsDir + '/fileCache/' + fileName;
			if (!general_fs.existSync({ path: localName }).exist) { //判断是否在手机内存中
				api.download({
					url: filePath,
					savePath: localName,
					report: true,
					cache: true,
					allowResume: true
				}, function (ret, err) {
					if (ret) {
						if (ret.state == 1) {
							console.log("缓存这个附件成功:" + JSON.stringify(ret));
							_item.state = 2;
							_item.schedule = -1;
							_item.path = localName;
							that.$forceUpdate();
							if (_ifOpen)
								that.annexOpen(_item);
						} else if (ret.state == 2) {
							_item.state = 3;
							that.$forceUpdate();
						} else if (ret.state == 0) {
							_item.state = 1;
							_item.schedule = ret.percent;
						}
					} else {
						_item.state = 3;
						that.$forceUpdate();
					}
				});
			} else {
				_item.state = 2;
				_item.schedule = -1;
				_item.path = localName;
				if (_ifOpen)
					that.annexOpen(_item);
			}
		}
	},
	//打开附件
	annexOpen: function (_item) {
		var that = this;
		if (T.isAPICloud()) {
			T.hideProgress();
			if (true) {
				var myParam = {};
				myParam.pageType = "page";//打开页面方式	home 首页一级模块	 page 作为页面被打开
				myParam.pageOnly = T.getNum();//表示页面唯一参数	必传
				myParam.footerH = 0;//底部按钮高度 传home时会有
				myParam.title = _item.name;//页面名字
				myParam.item = _item;
				T.openWin("superFile_win" + myParam.pageOnly, scriptPrefix + "html/api_module/mo_superFile/superFile_win.html", myParam, true, false);
			} else {
			}
		}
	},
	//获取 文件类型的各种属性
	getFileTypeAttr: function (_type) {
		var type = _type || "";
		type = type.toLocaleLowerCase(), iconInfo = { name: "icon_unknown.png", type: "unknown" };
		try {
			if (type.indexOf('.') != -1) type = type.split('.')[type.split('.').length - 1];
			switch (type) {
				case 'xlsx': case 'xlsm': case 'xlsb': case 'xltx': case 'xltm': case 'xls': case 'xlt': case 'et': case 'csv': case 'uos'://excel格式
					iconInfo.name = "icon_excel.png";
					iconInfo.type = "excel";
					iconInfo.convertType = "61";
					break;
				case 'doc': case 'docx': case 'docm': case 'dotx': case 'dotm': case 'dot': case 'xps': case 'rtf': case 'wps': case 'wpt': case 'uot'://word格式
					iconInfo.name = "icon_word.png";
					iconInfo.type = "word";
					iconInfo.convertType = "61";
					break;
				case 'pdf'://pdf格式
					iconInfo.name = "icon_pdf.png";
					iconInfo.type = "pdf";
					iconInfo.convertType = "20";
					break;
				case 'ppt': case 'pptx': case 'pps': case 'pot': case 'pptm': case 'potx': case 'potm': case 'ppsx': case 'ppsm': case 'ppa': case 'ppam': case 'dps': case 'dpt': case 'uop'://ppt
					iconInfo.name = "icon_ppt.png";
					iconInfo.type = "ppt";
					iconInfo.convertType = "61";
					break;
				case 'bmp': case 'gif': case 'jpg': case 'pic': case 'png': case 'tif': case 'jpeg': case 'jpe': case 'icon': case 'jfif': case 'dib'://图片格式
					iconInfo.name = "icon_pic.png";
					iconInfo.type = "image";
					iconInfo.convertType = "23";
					break;
				case 'txt'://文本
					iconInfo.name = "icon_txt.png";
					iconInfo.type = "txt";
					iconInfo.convertType = "61";
					break;
				case "rar": case "zip": case "7z": case "tar": case "gz": case "jar": case "ios"://压缩格式
					iconInfo.name = "icon_zip.png";
					iconInfo.type = "compression";
					iconInfo.convertType = "19";
					break;
				case "mp4": case "avi": case "flv": case "f4v": case "webm": case "m4v": case "mov": case "3gp": case "rm": case "rmvb": case "mkv"://视频格式
					iconInfo.name = "icon_mp4.png";
					iconInfo.type = "video";
					break;
				case "mp3": case "amr": case "pcm": case "wav": case "aiff": case "aac": case "ogg": case "wma": case "flac": case "alac": case "wma": case "cda"://音频格式
					iconInfo.name = "icon_mp3.png";
					iconInfo.type = "voice";
					break;
			}
		} catch (e) { console.error(e.message) }
		return iconInfo;
	},
	//获取文件大小
	getFileSize: function (_fileSize) {
		if (!_fileSize && _fileSize != 0) return '';
		try {
			var size1 = parseFloat((_fileSize / 1024 / 1024).toFixed(1))
			var size2 = parseFloat((_fileSize / 1024).toFixed(1))
			if (size1 >= 1) {
				return size1 + 'MB';
			} else if (size2 >= 1) {
				return size2 + 'KB';
			} else {
				return parseInt(_fileSize) + 'B';
			}
		} catch (e) {
			return _fileSize;
		}
	},
	//聊天共用方法集合 ================================================================================
	//获取用户或群组相关信息	 conversationType类型	targetId对方id	 _details为详情时	 _definition定义返回名字的字段
	getChatInfo: function (_item, callback, _details, _definition) {
		var that = this;
		var definition = _definition || {};
		var url = "";
		var prefix = (_details ? _item.senderUserId : _item.targetId).split(zyUrl.getChatHeader())[0];
		var targetId = (_details ? _item.senderUserId : _item.targetId).split(zyUrl.getChatHeader())[1];
		//	console.error(targetId);
		try {
			if (Number(targetId) < 0) {//为系统通知人 就不请求接口 直接返回系统人物属性
				if (targetId == "-1") {//智能助手
					_item[definition.name || "userName"] = "履职小助手";
					_item[definition.url || "url"] = (scriptPrefix + "images/icon_little_helper_"+(SYS_IF_ZX?'zx':'rd')+".png");
				}
				if (T.isFunction(callback)) {
					callback(_item);
				}
				return;
			}
		} catch (e) { console.error(e.message) }
		if (_item.conversationType == "PRIVATE" || _details) {
			url = zyUrl.getAppUrl() + "wholeuser/infoNotArea/" + targetId;
		} else if (_item.conversationType == "GROUP") {
			url = zyUrl.getAppUrl() + "talkroup/info/" + targetId;
		} else {
			return;
		}
		T.ajax({ u: url, c: false, ct: 5 }, 'ajax' + targetId + (_item.messageId)+(api.frameName||api.winName), function (ret, err) {
			if (ret) {
				var isDel = true;
				var name = "", img = "", position = "";
				var code = ret.errcode || "";
				var data = ret.data || "";
				if (code == "200" && data) {
					isDel = false;
					if (_item.conversationType == "PRIVATE" || _details) {
						var data = ret.data || {};
						name = data.userName || "";
						img = data.fullImgUrl || (scriptPrefix + "images/icon_default_user.png");
						position = data.position || "";
					} else if (_item.conversationType == "GROUP") {
						var data = ret.data || {};
						name = data.groupName || "";
						img = data.groupImgUrl || (scriptPrefix + "images/icon_default_group.png");
						_item.groupType = data.groupType || "";
						_item.groupOwner = data.groupOwner || "";
						_item.openSay = data.openSay || "";
						_item.moduleType = data.moduleType || "";
						_item.dictId = data.dictId || "";
					}
					_item[definition.name || "userName"] = name;
					_item[definition.url || "url"] = img;
					_item[definition.position || "position"] = position;
					general_db.executeSqlSync({ name: 'MYDATABASE', sql: "delete from chatInfo where type='" + (_details ? "PRIVATE" : _item.conversationType) + "' and id='" + (zyUrl.getChatHeader() + targetId) + "'" });
					general_db.executeSqlSync({ name: 'MYDATABASE', sql: "insert into chatInfo values('" + (_details ? "PRIVATE" : _item.conversationType) + "','" + (zyUrl.getChatHeader() + targetId) + "','" + name + "', '" + img + "')" });
					that.$forceUpdate();
				}
				_item.isDel = isDel;
				_item.refresh = "1";
				if (T.isFunction(callback)) {
					callback(_item);
				}
			}
		}, '获取' + _item.conversationType + '信息');
	},
	//获取状态背景样式	什么状态	什么场景 
	getColorStatus: function (_state, _scenes) {
		var that = this;
		var nItem = {};
		switch (_state) {
			case "报名中": case "未开始": case "预约会议": nItem = { t: "#0469CA" }; break;
			case "签到中": nItem = { t: "#007BFF" }; break;
			case "会议中": case "征集中": case "进行中": case "活动中": nItem = { t: that.appTheme }; break;
			default: nItem = { t: "#cccccc" }; break;
		}
		if (_scenes == 'bg') {
			return "background: " + T.colorRgba(nItem.t, '0.42') + ";";
		} else if (_scenes == 'angle') {
			return "border-top: " + ((that.appFontSize - 2) * 0.01) + "rem solid " + T.colorRgba(nItem.t, '1') + ";border-right: " + ((that.appFontSize - 2) * 0.01) + "rem solid transparent;";
		} else if (_scenes == 'text') {
			return "color: " + T.colorRgba(nItem.t, '1') + ";";
		} else {
			return nItem.t;
		}
	},
	//获取建议提案状态颜色 
	getColorModule:function(_state){
		var that = this;
		var nItem = {};
		switch (_state) {
			case "待审查":case "办理中": nItem = { t: "#144FC6" }; break;
			case "不予立案":  nItem = { t: "#333333" }; break;
			default: nItem = { t: "#C61414" }; break;
		}
		return nItem.t;
	},
	//图片正文中的图片及点击放大事件
	processContentImg: function (_dom) {
		var that = this;
		var contentImgs = $api.domAll(_dom || ".n_details_content img");
		var amplificationImgs = [];
		for (var i = 0; i < contentImgs.length; i++) {
			var cacheAddress = $api.attr(contentImgs[i], "src");
			if (cacheAddress) {
				$api.css(contentImgs[i], "height:auto;");//图片高度最大设置为100%	高度自适应
				amplificationImgs.push({ url: cacheAddress });
			}
		}
		for (var i = 0; i < contentImgs.length; i++) {
			(function (_index) {
				var cacheAddress = $api.attr(contentImgs[_index], "src");
				if (cacheAddress) {
					T.imageCache({ url: cacheAddress, thumbnail: false }, function (ret, err) {
						$api.attr(contentImgs[_index], "src", ret.url);
					});
					contentImgs[_index].onclick = function () {
						that.previewImg(amplificationImgs, _index);
					}
				}
			})(i);
		}
		var contentVideos = $api.domAll(_dom || ".n_details_content video");
		(contentVideos||[]).forEach(function (_eItem) {
			var src = $api.attr(_eItem, "src");
			if(src){
				(src.indexOf("#t=") == -1) && $api.attr(_eItem, "src",src + "#t=0.1");//设置一下跳转 显示缩略图
				$api.attr(_eItem, "webkit-playsinline","true");
				$api.attr(_eItem, "x5-playsinline","true");
				$api.attr(_eItem, "playsinline","true");
				_eItem.pause();
			}
		});

	},
	//下拉框被打开了
	dropdownOpen:function(){
		var scrollTop = document.documentElement.scrollTop || document.body.scrollTop;//当前body距顶
		var frameHeight = T.frameHeight();//当前页面总高度
		var nowHeight = $api.offset($api.dom("#app")).h;//当前页面高度
		if(nowHeight < frameHeight){
			$api.byId("app").insertAdjacentHTML('beforeend', "<div class='dropdownP' style='width:100%;height:"+(frameHeight-nowHeight+20)+"px;'></div>");
		}
		if(!scrollTop){
			document.documentElement.scrollTop = 1;
			document.body.scrollTop = 1;
		}
	},
	//下拉框被关闭了
	dropdownClosed:function(){
		var dropdownP = $api.dom(".dropdownP");
		if(dropdownP){
			dropdownP.parentNode.removeChild(dropdownP);
		}
	},
};
var nvmData = {}, nvmWatch = {}, nvmMethods = {};
T.ready(function () {
	try {
		nvmData = T.setNewJSON(DEFAULT_DATA, vmData);
		nvmWatch = T.setNewJSON(DEFAULT_WATCH, vmWatch);
		nvmMethods = T.setNewJSON(DEFAULT_METHODS, vmMethods);
	} catch (e) { console.error(e.message) }
	vm = new Vue({
		el: '#app',
		data: nvmData,
		watch: nvmWatch,
		mounted: function () {//页面元素加载完成时调用
			var that = this;
			try { that.defalutInit(); } catch (e) { console.error(e.message) }
			try { that.init(); } catch (e) { console.error(e.message) }
		},
		methods: nvmMethods
	});
});

//划动页面时 监听
var footerBtnsShowTimeout;
window.onscroll = function () {
	var scrollTop = document.documentElement.scrollTop || document.body.scrollTop;
	nvmData.scrollTop = scrollTop;
	// nvmData.footerBtnsShow = true;
	// footerBtnsShowTimeout && clearTimeout(footerBtnsShowTimeout);
	// footerBtnsShowTimeout = setTimeout(function () {
	// 	if ($api.offset($api.dom("#app")).h >= T.frameHeight())
	// 		nvmData.footerBtnsShow = false;
	// }, 5000);
}

//旋转屏幕后	改一下顶部
window.addEventListener("orientationchange", function() {
	if(window.orientation != 0){
		nvmData.safeAreaTop = 25;
	}else{
		nvmData.safeAreaTop = api.safeArea.top;
	}
}, false);

//图片共用方法集合 ================================================================================
//计算图片是否需要高斯模糊
function calculateProportion(_this,_item){
	var that = _this;
	var baseUrl = _item.url || "";
	if(baseUrl && baseUrl.indexOf('http') != 0 && baseUrl.indexOf('icon_placeholder') == -1){//有图片 不是http地址 不是占位图的时候 
		var sqlUrl = encodeURIComponent(baseUrl).replace(/\-/g, "%2D").replace(/\_/g, "%5F").replace(/\./g, "%2E").replace(/\!/g, "%21").replace(/\~/g, "%7E").replace(/\*/g, "%2A").replace(/\'/g, "%27");
		if(!window.imageProportionCache) window.imageProportionCache = {};
		_item.nowProportion = window.imageProportionCache[sqlUrl] || 0;//当前宽高比例 保留2位小数
		if(_item.nowProportion) return;//计算了就不再计算 
		var img = new Image();
		img.onload=function(){
			if(img.width || img.height){
				_item.nowProportion = Number((img.width/img.height).toFixed(2));
				// console.log(baseUrl + "-" + img.width + "-" + img.height + "=" + _item.nowProportion);
			}
			window.imageProportionCache[sqlUrl] = _item.nowProportion;
			img = null;//释放局部变量
			that.$forceUpdate();
		};
		img.src = baseUrl;
	}
};
//共用缓存方法	item需要一个url参数
function cacheImg(_this, _item, _thumbnail, _url, _priority) {
	var that = _this;
	if(!_item) return;
	var baseUrl = _item.webImg || _url || _item.url || "";//存储当前缓存地址
	if(!_item.url&&!_item.dotDefault&&!_item.webImg) _item.url = scriptPrefix + "images/icon_placeholder.png";
	if (T.isAPICloud() && baseUrl.indexOf('http') == 0 && general_db){//是apicloud环境 并且是http地址
		_item.baseUrl = baseUrl;
		if(!_item.dotDefault&&!_item.webImg){
			_item.url = scriptPrefix + "images/icon_placeholder.png";//当前先展示占位图片
		}
		var sqlUrl = encodeURIComponent(baseUrl).replace(/\-/g, "%2D").replace(/\_/g, "%5F").replace(/\./g, "%2E").replace(/\!/g, "%21").replace(/\~/g, "%7E").replace(/\*/g, "%2A").replace(/\'/g, "%27");
		if(vm.getItemForKey(sqlUrl,inImgList) && _item._inCache){//正在获取中 并且正在缓存
			return;
		}
		if(!window.imageCache) window.imageCache = {};
		var sqlret;
		if(window.imageCache[sqlUrl]){//先从页面上取	减少db压力
			sqlret = {data:[{base64:window.imageCache[sqlUrl]}]};
		}else{
			sqlret = general_db.selectSqlSync({ name: 'MYDATABASE', sql: "select * from imgInfo where src='" + sqlUrl + "'" });
		}
		var sqlData = sqlret.data || [];
		if (sqlData.length && sqlData[0].base64 && general_fs.existSync({ path: sqlData[0].base64 }).exist) {
			_item.url = sqlData[0].base64;
			_item.webImg = "";
			window.imageCache[sqlUrl] = _item.url;
			_item._inCache = false;
			that.$forceUpdate();
			// console.log("缓存数据："+_item.url);
		}else{
			if(!vm.getItemForKey(sqlUrl,inImgList) || !_item._inCache){//当前图片没有在获取缓存中 或者 并且没有在缓存  可能是多张相同地址图片
				_item._inCache = true;
				if (_priority) {
					waitImgList.unshift({ item: _item, thumbnail: _thumbnail });
				} else {
					waitImgList.push({ item: _item, thumbnail: _thumbnail });
				}
				addThread(that);
			}
		}
	}
	// that.calculateProportion(_item);
};
//添加进缓存池 多线程
function addThread(_this) {
	var that = _this;
	if (!waitImgList.length) {
		return;
	}
	threadList.forEach(function (_eItem, _eIndex, _eArr) {//item index 原数组对象
		if (!threadList[_eIndex] && waitImgList.length) {
			threadList[_eIndex] = waitImgList[0];
			waitImgList.shift();
			var nUrl = threadList[_eIndex].item.baseUrl || "";
			var sqlUrl = encodeURIComponent(nUrl).replace(/\-/g, "%2D").replace(/\_/g, "%5F").replace(/\./g, "%2E").replace(/\!/g, "%21").replace(/\~/g, "%7E").replace(/\*/g, "%2A").replace(/\'/g, "%27");
			inImgList.push(sqlUrl);
			// console.error("线程"+_eIndex+"开始任务" + JSON.stringify(threadList[_eIndex]));
			// console.error("剩余线程"+JSON.stringify(threadList));
			T.imageCache({ url: nUrl, thumbnail: false }, function (ret, err) {//缓存网络图片
				if(ret && ret.status){
					var fileUrl = ret.url;
					var transPathSize = general_fs.getAttributeSync({ path: fileUrl }).attribute.size;
					transPathSize = (transPathSize * 0.001).toFixed(2);
					var quality = Number(transPathSize > 1024 ? (1024 / transPathSize).toFixed(1) : 0.9);
					quality = quality > 0.9?0.9:quality;
					// console.log(quality + ",压缩前大小：" + general_fs.getAttributeSync({ path: fileUrl }).attribute.size + "," + fileUrl);
					//暂时的方法 图标不是透明才做压缩处理 
					general_colorGain.getColor({ path: fileUrl,rect:{x:0,y:0} }, function (ret) {
						var color = (ret?ret.color||"":"").replace('rgba', 'rgb');
						console.log(nUrl + "," + JSON.stringify(ret));
						//没有颜色或者不为透明 并且 大于1.5M的图片才压缩 
						if((!color || color != "rgb(0,0,0)") && general_fs.getAttributeSync({ path: fileUrl }).attribute.size > 1572864 && general_imageTools){
							general_imageTools.compression({ path:fileUrl,value:Number(quality)}, function (ret, err) {//压缩图片大小
								var commpressUrl = ret.path || fileUrl;
								// console.log("压缩后大小：" + general_fs.getAttributeSync({ path: commpressUrl }).attribute.size + "," + commpressUrl);
								general_db.executeSqlSync({ name: 'MYDATABASE', sql: "delete from imgInfo where src='" + sqlUrl + "'" });
								general_db.executeSqlSync({ name: 'MYDATABASE', sql: "insert into imgInfo values('" + sqlUrl + "','" + commpressUrl + "','" + Math.round(new Date().getTime() / 1000) + "')" });
								threadList[_eIndex].item.url = commpressUrl;
								threadList[_eIndex].item.webImg = "";
								threadList[_eIndex].item.nowProportion = 0;
								window.imageCache[sqlUrl] = commpressUrl;
								threadList[_eIndex].item._inCache = false;
								// console.error("线程"+_eIndex+"结束任务，" + nUrl);
								vm.delItemForKey(sqlUrl,inImgList);
								threadList[_eIndex] = "";
								addThread(that);
								that.$forceUpdate();
							});
						}else{
							var commpressUrl = ret.path || fileUrl;
							// console.log("压缩后大小：" + general_fs.getAttributeSync({ path: commpressUrl }).attribute.size + "," + commpressUrl);
							general_db.executeSqlSync({ name: 'MYDATABASE', sql: "delete from imgInfo where src='" + sqlUrl + "'" });
							general_db.executeSqlSync({ name: 'MYDATABASE', sql: "insert into imgInfo values('" + sqlUrl + "','" + commpressUrl + "','" + Math.round(new Date().getTime() / 1000) + "')" });
							threadList[_eIndex].item.url = commpressUrl;
							threadList[_eIndex].item.webImg = "";
							threadList[_eIndex].item.nowProportion = 0;
							window.imageCache[sqlUrl] = commpressUrl;
							threadList[_eIndex].item._inCache = false;
							// console.error("线程"+_eIndex+"结束任务，" + nUrl);
							vm.delItemForKey(sqlUrl,inImgList);
							threadList[_eIndex] = "";
							addThread(that);
						}
						that.$forceUpdate();
					});
				}else{
					// that.delItemForKey(nUrl,inImgList);//失败的不删除 不然一直请求
					threadList[_eIndex] = "";
					addThread(that);
				}
				that.$forceUpdate();
			});
		}
	});
};

//字体共用方法集合 ================================================================================
//样式加载配置
function loadConfiguration (_changeSize, _max) {
	var changeSize = _changeSize || 0;
	return "font-size:" + ((nvmData.appFontSize > _max ? _max : nvmData.appFontSize + changeSize) * 0.01) + "rem;font-family:" + nvmData.appFont + ";";
}
//根据配置大小	设置按钮 图片等宽高 +-N
function loadConfigurationSize (_changeSize, _who) {
	var changeSize = _changeSize || 0;
	var returnCss = "";
	var cssWidth, cssHeight;
	if (T.isArray(_changeSize)) {
		cssWidth = "width:" + ((nvmData.appFontSize + (_changeSize[0] || 0)) * 0.01) + "rem;";
		cssHeight = "height:" + ((nvmData.appFontSize + (_changeSize[1] || 0)) * 0.01) + "rem;";
	} else {
		cssWidth = "width:" + ((nvmData.appFontSize + changeSize) * 0.01) + "rem;";
		cssHeight = "height:" + ((nvmData.appFontSize + changeSize) * 0.01) + "rem;";
	}
	if (!_who) {
		returnCss = cssWidth + cssHeight;
	} else {
		returnCss = _who == 'w' ? cssWidth : cssHeight;
	}
	return returnCss;
}


//共用组件
/**
 * //用户头像处理组件
 */
 var zyPhoto = {
	props: ["data","imgid"],
	watch: {
	},
	mounted: function() {
		// console.log("----"+JSON.stringify(this.data));
	},
	methods: {
		startImg:function(_item){
			cacheImg(this,_item);
			calculateProportion(this,_item);
		},
	},
	template:`<div class="component_user_img_radius" :alt="startImg(data)">
				<img v-if="data.nowProportion?(data.nowProportion>0.9&&data.nowProportion<1.1):true" :id="imgid" class="component_user_img_cover" :src="data.url"/>
				<template v-else>
					<div class="component_user_img_filter" :style="\'background-image:url(\'+data.url+\')\'" ></div>
					<div class="component_user_img_warp flex_box flex_align_center flex_justify_content" >
						<img :id="imgid" class="component_user_img_contain" :src="data.url"/>
					</div>
				</template>
			</div>`,
};
Vue.component('zy-photo', zyPhoto);

/**
 * //选择人员划块组件
 */
 var zySelectUser = {
	props: ["data","maxrow","crop"],
	watch: {
	},
	mounted: function() {
	},
	methods: {
		showName:function(_item){
			var that = this;
			if(that.crop && _item.name.indexOf(that.crop) != -1){//有裁切字段  并且名字里有
				return _item.name.substring(0,_item.name.lastIndexOf(that.crop));
			}
			return _item.name;
		}
	},
	template:`<div class="component_selectuser_warp flex_box flex_align_center" @touchstart="if(window.groupTimeout)clearTimeout(window.groupTimeout);window.notClose=true;" @touchend="window.groupTimeout=setTimeout(function(){window.notClose=false;},300);">
				<div class="flex_placeholder component_selectuser_box">
					<div v-for="(item,index) in data" class="component_selectuser_item" @click="$emit('click',item)">
						<van-icon v-if="!item.notDel" @click.stop="vm.delItemForKey(index,data)" class="component_selectuser_del" :size="((nvmData.appFontSize)*0.01)+'rem'" color="#7F7F7F" name="clear"></van-icon>
						<zy-photo :style="loadConfigurationSize(22)+'margin:auto;'" :key="item.refresh" :data="item"></zy-photo>
						<div class="component_selectuser_name" :style="loadConfiguration(-2)+'-webkit-line-clamp: '+(maxrow||3)+';'">{{showName(item)}}</div>
					</div>
				</div>
			</div>`,
};
Vue.component('zy-selectuser', zySelectUser);

